{******************************************************************************}
{*                                                                            *}
{*  Copyright (C) Microsoft Corporation.  All Rights Reserved.                *}
{*                                                                            *}
{*  Files:      D3D10.h D3D10Misc.h D3D10Shader.h                             *}
{*  Content:    Direct3D10 include files                                      *}
{*                                                                            *}
{*  DirectX Delphi / FreePascal adaptation by Alexey Barkovoy                 *}
{*  E-Mail: directx@clootie.ru                                                *}
{*                                                                            *}
{*  Latest version can be downloaded from:                                    *}
{*    http://www.clootie.ru                                                   *}
{*    http://sourceforge.net/projects/delphi-dx9sdk                           *}
{*                                                                            *}
{*----------------------------------------------------------------------------*}
{*  $Id: $ }
{******************************************************************************}
{                                                                              }
{ Obtained through: Joint Endeavour of Delphi Innovators (Project JEDI)        }
{                                                                              }
{ The contents of this file are used with permission, subject to the Mozilla   }
{ Public License Version 1.1 (the "License"); you may not use this file except }
{ in compliance with the License. You may obtain a copy of the License at      }
{ http://www.mozilla.org/MPL/MPL-1.1.html                                      }
{                                                                              }
{ Software distributed under the License is distributed on an "AS IS" basis,   }
{ WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for }
{ the specific language governing rights and limitations under the License.    }
{                                                                              }
{ Alternatively, the contents of this file may be used under the terms of the  }
{ GNU Lesser General Public License (the  "LGPL License"), in which case the   }
{ provisions of the LGPL License are applicable instead of those above.        }
{ If you wish to allow use of your version of this file only under the terms   }
{ of the LGPL License and not to allow others to use your version of this file }
{ under the MPL, indicate your decision by deleting  the provisions above and  }
{ replace  them with the notice and other provisions required by the LGPL      }
{ License.  If you do not delete the provisions above, a recipient may use     }
{ your version of this file under either the MPL or the LGPL License.          }
{                                                                              }
{ For more information about the LGPL: http://www.gnu.org/copyleft/lesser.html }
{                                                                              }
{******************************************************************************}
{**********************************************************************
 Package pl_Win_DirectX.pkg
 CodeTyphon Studio (http://www.pilotlogic.com/)
***********************************************************************}

unit D3D10;

{$ALIGN ON}
{$MINENUMSIZE 4}
{$WEAKPACKAGEUNIT}

interface


uses
  Windows, DXTypes, DXGI, DxgiType, DxgiFormat;


//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10.h
//  Content:
//
//////////////////////////////////////////////////////////////////////////////

const
  D3D10dll = 'd3d10.dll';

const
  D3D10_16BIT_INDEX_STRIP_CUT_VALUE = $ffff;
  D3D10_32BIT_INDEX_STRIP_CUT_VALUE = $ffffffff;
  D3D10_8BIT_INDEX_STRIP_CUT_VALUE = $ff;
  D3D10_ARRAY_AXIS_ADDRESS_RANGE_BIT_COUNT = 9;
  D3D10_CLIP_OR_CULL_DISTANCE_COUNT = 8;
  D3D10_CLIP_OR_CULL_DISTANCE_ELEMENT_COUNT = 2;

  D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT	= 14;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_COMPONENTS = 4;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_COMPONENT_BIT_COUNT = 32;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_HW_SLOT_COUNT = 15;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_REGISTER_COMPONENTS = 4;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_REGISTER_COUNT = 15;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_REGISTER_READS_PER_INST = 1;
  D3D10_COMMONSHADER_CONSTANT_BUFFER_REGISTER_READ_PORTS = 1;

  D3D10_COMMONSHADER_FLOWCONTROL_NESTING_LIMIT = 64;

  D3D10_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_COMPONENTS = 4;
  D3D10_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_COUNT = 1;
  D3D10_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_READS_PER_INST = 1;
  D3D10_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_READ_PORTS = 1;
  D3D10_COMMONSHADER_IMMEDIATE_VALUE_COMPONENT_BIT_COUNT = 32;

  D3D10_COMMONSHADER_INPUT_RESOURCE_REGISTER_COMPONENTS = 1;
  D3D10_COMMONSHADER_INPUT_RESOURCE_REGISTER_COUNT = 128;
  D3D10_COMMONSHADER_INPUT_RESOURCE_REGISTER_READS_PER_INST = 1;
  D3D10_COMMONSHADER_INPUT_RESOURCE_REGISTER_READ_PORTS = 1;
  D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT = 128;

  D3D10_COMMONSHADER_SAMPLER_REGISTER_COMPONENTS = 1;
  D3D10_COMMONSHADER_SAMPLER_REGISTER_COUNT = 16;
  D3D10_COMMONSHADER_SAMPLER_REGISTER_READS_PER_INST = 1;
  D3D10_COMMONSHADER_SAMPLER_REGISTER_READ_PORTS = 1;
  D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT = 16;

  D3D10_COMMONSHADER_SUBROUTINE_NESTING_LIMIT = 32;

  D3D10_COMMONSHADER_TEMP_REGISTER_COMPONENTS = 4;
  D3D10_COMMONSHADER_TEMP_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_COMMONSHADER_TEMP_REGISTER_COUNT = 4096;
  D3D10_COMMONSHADER_TEMP_REGISTER_READS_PER_INST = 3;
  D3D10_COMMONSHADER_TEMP_REGISTER_READ_PORTS = 3;

  D3D10_COMMONSHADER_TEXCOORD_RANGE_REDUCTION_MAX = 10;
  D3D10_COMMONSHADER_TEXCOORD_RANGE_REDUCTION_MIN = -10;

  D3D10_COMMONSHADER_TEXEL_OFFSET_MAX_NEGATIVE = -8;
  D3D10_COMMONSHADER_TEXEL_OFFSET_MAX_POSITIVE = 7;

  D3D10_DEFAULT_BLEND_FACTOR_ALPHA = 1.0;
  D3D10_DEFAULT_BLEND_FACTOR_BLUE = 1.0;
  D3D10_DEFAULT_BLEND_FACTOR_GREEN = 1.0;
  D3D10_DEFAULT_BLEND_FACTOR_RED = 1.0;

  D3D10_DEFAULT_BORDER_COLOR_COMPONENT = 0.0;

  D3D10_DEFAULT_DEPTH_BIAS = 0;
  D3D10_DEFAULT_DEPTH_BIAS_CLAMP = 0.0;

  D3D10_DEFAULT_MAX_ANISOTROPY = 16.0;
  D3D10_DEFAULT_MIP_LOD_BIAS = 0.0;
  D3D10_DEFAULT_RENDER_TARGET_ARRAY_INDEX = 0;

  D3D10_DEFAULT_SAMPLE_MASK = $ffffffff;

  D3D10_DEFAULT_SCISSOR_ENDX = 0;
  D3D10_DEFAULT_SCISSOR_ENDY = 0;
  D3D10_DEFAULT_SCISSOR_STARTX = 0;
  D3D10_DEFAULT_SCISSOR_STARTY = 0;

  D3D10_DEFAULT_SLOPE_SCALED_DEPTH_BIAS = 0.0;

  D3D10_DEFAULT_STENCIL_READ_MASK = $ff;

  D3D10_DEFAULT_STENCIL_REFERENCE = 0;

  D3D10_DEFAULT_STENCIL_WRITE_MASK = $ff;

  D3D10_DEFAULT_VIEWPORT_AND_SCISSORRECT_INDEX = 0;

  D3D10_DEFAULT_VIEWPORT_HEIGHT = 0;
  D3D10_DEFAULT_VIEWPORT_MAX_DEPTH = 0.0;
  D3D10_DEFAULT_VIEWPORT_MIN_DEPTH = 0.0;
  D3D10_DEFAULT_VIEWPORT_TOPLEFTX = 0;
  D3D10_DEFAULT_VIEWPORT_TOPLEFTY = 0;
  D3D10_DEFAULT_VIEWPORT_WIDTH = 0;

  D3D10_FLOAT16_FUSED_TOLERANCE_IN_ULP = 0.6;

  D3D10_FLOAT32_MAX = 3.402823466e+38;
  D3D10_FLOAT32_TO_INTEGER_TOLERANCE_IN_ULP = 0.6;
  D3D10_FLOAT_TO_SRGB_EXPONENT_DENOMINATOR = 2.4;
  D3D10_FLOAT_TO_SRGB_EXPONENT_NUMERATOR = 1.0;
  D3D10_FLOAT_TO_SRGB_OFFSET = 0.055;
  D3D10_FLOAT_TO_SRGB_SCALE_1 = 12.92;
  D3D10_FLOAT_TO_SRGB_SCALE_2 = 1.055;
  D3D10_FLOAT_TO_SRGB_THRESHOLD = 0.0031308;
  D3D10_FTOI_INSTRUCTION_MAX_INPUT = 2147483647.999;
  D3D10_FTOI_INSTRUCTION_MIN_INPUT = -2147483648.999;
  D3D10_FTOU_INSTRUCTION_MAX_INPUT = 4294967295.999;
  D3D10_FTOU_INSTRUCTION_MIN_INPUT = 0.0;
  D3D10_GS_INPUT_PRIM_CONST_REGISTER_COMPONENTS = 1;

  D3D10_GS_INPUT_PRIM_CONST_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_GS_INPUT_PRIM_CONST_REGISTER_COUNT = 1;
  D3D10_GS_INPUT_PRIM_CONST_REGISTER_READS_PER_INST = 2;
  D3D10_GS_INPUT_PRIM_CONST_REGISTER_READ_PORTS = 1;
  D3D10_GS_INPUT_REGISTER_COMPONENTS = 4;
  D3D10_GS_INPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_GS_INPUT_REGISTER_COUNT = 16;
  D3D10_GS_INPUT_REGISTER_READS_PER_INST = 2;
  D3D10_GS_INPUT_REGISTER_READ_PORTS = 1;
  D3D10_GS_INPUT_REGISTER_VERTICES = 6;
  D3D10_GS_OUTPUT_ELEMENTS = 32;
  D3D10_GS_OUTPUT_REGISTER_COMPONENTS = 4;
  D3D10_GS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_GS_OUTPUT_REGISTER_COUNT = 32;

  D3D10_IA_DEFAULT_INDEX_BUFFER_OFFSET_IN_BYTES = 0;
  D3D10_IA_DEFAULT_PRIMITIVE_TOPOLOGY = 0;
  D3D10_IA_DEFAULT_VERTEX_BUFFER_OFFSET_IN_BYTES = 0;
  D3D10_IA_INDEX_INPUT_RESOURCE_SLOT_COUNT = 1;
  D3D10_IA_INSTANCE_ID_BIT_COUNT = 32;
  D3D10_IA_INTEGER_ARITHMETIC_BIT_COUNT = 32;
  D3D10_IA_PRIMITIVE_ID_BIT_COUNT = 32;
  D3D10_IA_VERTEX_ID_BIT_COUNT = 32;
  D3D10_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT = 16;
  D3D10_IA_VERTEX_INPUT_STRUCTURE_ELEMENTS_COMPONENTS = 64;
  D3D10_IA_VERTEX_INPUT_STRUCTURE_ELEMENT_COUNT = 16;

  D3D10_INTEGER_DIVIDE_BY_ZERO_QUOTIENT = $ffffffff;
  D3D10_INTEGER_DIVIDE_BY_ZERO_REMAINDER = $ffffffff;

  D3D10_LINEAR_GAMMA = 1.0;
  D3D10_MAX_BORDER_COLOR_COMPONENT = 1.0;
  D3D10_MAX_DEPTH = 1.0;
  D3D10_MAX_MAXANISOTROPY = 16;

  D3D10_MAX_MULTISAMPLE_SAMPLE_COUNT = 32;

  D3D10_MAX_POSITION_VALUE = 3.402823466e+34;
  D3D10_MAX_TEXTURE_DIMENSION_2_TO_EXP = 17;

  D3D10_MIN_BORDER_COLOR_COMPONENT = 0.0;
  D3D10_MIN_DEPTH = 0.0;
  D3D10_MIN_MAXANISOTROPY = 0;

  D3D10_MIP_LOD_BIAS_MAX = 15.99;
  D3D10_MIP_LOD_BIAS_MIN = -16.0;
  D3D10_MIP_LOD_FRACTIONAL_BIT_COUNT = 6;

  D3D10_MIP_LOD_RANGE_BIT_COUNT = 8;

  D3D10_MULTISAMPLE_ANTIALIAS_LINE_WIDTH = 1.4;
  D3D10_NONSAMPLE_FETCH_OUT_OF_RANGE_ACCESS_RESULT = 0;

  D3D10_PIXEL_ADDRESS_RANGE_BIT_COUNT = 13;

  D3D10_PRE_SCISSOR_PIXEL_ADDRESS_RANGE_BIT_COUNT = 15;

  D3D10_PS_FRONTFACING_DEFAULT_VALUE = $ffffffff;
  D3D10_PS_FRONTFACING_FALSE_VALUE = 0;
  D3D10_PS_FRONTFACING_TRUE_VALUE = $ffffffff;
  D3D10_PS_INPUT_REGISTER_COMPONENTS = 4;
  D3D10_PS_INPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_PS_INPUT_REGISTER_COUNT = 32;
  D3D10_PS_INPUT_REGISTER_READS_PER_INST = 2;
  D3D10_PS_INPUT_REGISTER_READ_PORTS = 1;

  D3D10_PS_LEGACY_PIXEL_CENTER_FRACTIONAL_COMPONENT = 0.0;

  D3D10_PS_OUTPUT_DEPTH_REGISTER_COMPONENTS = 1;
  D3D10_PS_OUTPUT_DEPTH_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_PS_OUTPUT_DEPTH_REGISTER_COUNT = 1;
  D3D10_PS_OUTPUT_REGISTER_COMPONENTS = 4;
  D3D10_PS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_PS_OUTPUT_REGISTER_COUNT = 8;

  D3D10_PS_PIXEL_CENTER_FRACTIONAL_COMPONENT = 0.5;
  D3D10_REQ_BLEND_OBJECT_COUNT_PER_CONTEXT = 4096;

  D3D10_REQ_BUFFER_RESOURCE_TEXEL_COUNT_2_TO_EXP = 27;
  D3D10_REQ_CONSTANT_BUFFER_ELEMENT_COUNT = 4096;
  D3D10_REQ_DEPTH_STENCIL_OBJECT_COUNT_PER_CONTEXT = 4096;
  D3D10_REQ_DRAWINDEXED_INDEX_COUNT_2_TO_EXP = 32;
  D3D10_REQ_DRAW_VERTEX_COUNT_2_TO_EXP = 32;
  D3D10_REQ_FILTERING_HW_ADDRESSABLE_RESOURCE_DIMENSION = 8192;
  D3D10_REQ_GS_INVOCATION_32BIT_OUTPUT_COMPONENT_LIMIT = 1024;
  D3D10_REQ_IMMEDIATE_CONSTANT_BUFFER_ELEMENT_COUNT = 4096;
  D3D10_REQ_MAXANISOTROPY = 16;
  D3D10_REQ_MIP_LEVELS = 14;
  D3D10_REQ_MULTI_ELEMENT_STRUCTURE_SIZE_IN_BYTES = 2048;
  D3D10_REQ_RASTERIZER_OBJECT_COUNT_PER_CONTEXT = 4096;
  D3D10_REQ_RENDER_TO_BUFFER_WINDOW_WIDTH = 8192;
  D3D10_REQ_RESOURCE_SIZE_IN_MEGABYTES = 128;
  D3D10_REQ_RESOURCE_VIEW_COUNT_PER_CONTEXT_2_TO_EXP = 20;
  D3D10_REQ_SAMPLER_OBJECT_COUNT_PER_CONTEXT = 4096;
  D3D10_REQ_TEXTURE1D_ARRAY_AXIS_DIMENSION = 512;
  D3D10_REQ_TEXTURE1D_U_DIMENSION = 8192;
  D3D10_REQ_TEXTURE2D_ARRAY_AXIS_DIMENSION = 512;
  D3D10_REQ_TEXTURE2D_U_OR_V_DIMENSION = 8192;
  D3D10_REQ_TEXTURE3D_U_V_OR_W_DIMENSION = 2048;
  D3D10_REQ_TEXTURECUBE_DIMENSION = 8192;
  D3D10_RESINFO_INSTRUCTION_MISSING_COMPONENT_RETVAL = 0;

  D3D10_SHADER_MAJOR_VERSION = 4;
  D3D10_SHADER_MINOR_VERSION = 0;

  D3D10_SHIFT_INSTRUCTION_PAD_VALUE = 0;

  D3D10_SHIFT_INSTRUCTION_SHIFT_VALUE_BIT_COUNT = 5;

  D3D10_SIMULTANEOUS_RENDER_TARGET_COUNT = 8;

  D3D10_SO_BUFFER_MAX_STRIDE_IN_BYTES = 2048;
  D3D10_SO_BUFFER_MAX_WRITE_WINDOW_IN_BYTES = 256;
  D3D10_SO_BUFFER_SLOT_COUNT = 4;
  D3D10_SO_DDI_REGISTER_INDEX_DENOTING_GAP = $ffffffff;
  D3D10_SO_MULTIPLE_BUFFER_ELEMENTS_PER_BUFFER = 1;
  D3D10_SO_SINGLE_BUFFER_COMPONENT_LIMIT = 64;

  D3D10_SRGB_GAMMA = 2.2;
  D3D10_SRGB_TO_FLOAT_DENOMINATOR_1 = 12.92;
  D3D10_SRGB_TO_FLOAT_DENOMINATOR_2 = 1.055;
  D3D10_SRGB_TO_FLOAT_EXPONENT = 2.4;
  D3D10_SRGB_TO_FLOAT_OFFSET = 0.055;
  D3D10_SRGB_TO_FLOAT_THRESHOLD = 0.04045;
  D3D10_SRGB_TO_FLOAT_TOLERANCE_IN_ULP = 0.5;

  D3D10_STANDARD_COMPONENT_BIT_COUNT = 32;
  D3D10_STANDARD_COMPONENT_BIT_COUNT_DOUBLED = 64;
  D3D10_STANDARD_MAXIMUM_ELEMENT_ALIGNMENT_BYTE_MULTIPLE = 4;
  D3D10_STANDARD_PIXEL_COMPONENT_COUNT = 128;
  D3D10_STANDARD_PIXEL_ELEMENT_COUNT = 32;
  D3D10_STANDARD_VECTOR_SIZE = 4;
  D3D10_STANDARD_VERTEX_ELEMENT_COUNT = 16;
  D3D10_STANDARD_VERTEX_TOTAL_COMPONENT_COUNT = 64;

  D3D10_SUBPIXEL_FRACTIONAL_BIT_COUNT = 8;

  D3D10_SUBTEXEL_FRACTIONAL_BIT_COUNT = 6;

  D3D10_TEXEL_ADDRESS_RANGE_BIT_COUNT = 18;

  D3D10_UNBOUND_MEMORY_ACCESS_RESULT = 0;

  D3D10_VIEWPORT_AND_SCISSORRECT_MAX_INDEX = 15;

  D3D10_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE = 16;

  D3D10_VIEWPORT_BOUNDS_MAX = 16383;

  D3D10_VIEWPORT_BOUNDS_MIN = -16384;

  D3D10_VS_INPUT_REGISTER_COMPONENTS = 4;
  D3D10_VS_INPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_VS_INPUT_REGISTER_COUNT = 16;
  D3D10_VS_INPUT_REGISTER_READS_PER_INST = 2;
  D3D10_VS_INPUT_REGISTER_READ_PORTS = 1;

  D3D10_VS_OUTPUT_REGISTER_COMPONENTS = 4;
  D3D10_VS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = 32;
  D3D10_VS_OUTPUT_REGISTER_COUNT = 16;

  D3D10_WHQL_CONTEXT_COUNT_FOR_RESOURCE_LIMIT = 10;
  D3D10_WHQL_DRAWINDEXED_INDEX_COUNT_2_TO_EXP = 25;
  D3D10_WHQL_DRAW_VERTEX_COUNT_2_TO_EXP = 25;

  D3D_MAJOR_VERSION   = 10;
  D3D_MINOR_VERSION   = 0;
  D3D_SPEC_DATE_DAY   = 8;
  D3D_SPEC_DATE_MONTH = 8;
  D3D_SPEC_DATE_YEAR  = 2006;
  D3D_SPEC_VERSION    = 1.050005;

  WGF_MAJOR_VERSION = 2;
  WGF_MINOR_VERSION = 0;

  _FACD3D10 = $879;
  _FACD3D10DEBUG = _FACD3D10 + 1;


function MAKE_D3D10_HRESULT(Code: DWord): DWord; inline;
function MAKE_D3D10_STATUS(Code: DWord): DWord; inline;

const
  MAKE_D3D10HRESULT_R     = (1 shl 31) or (_FACD3D10 shl 16);

  D3D10_ERROR_TOO_MANY_UNIQUE_STATE_OBJECTS = HResult(MAKE_D3D10HRESULT_R or 1);
  D3D10_ERROR_FILE_NOT_FOUND                = HResult(MAKE_D3D10HRESULT_R or 2);

type
  D3D10_INPUT_CLASSIFICATION = (
    D3D10_INPUT_PER_VERTEX_DATA = 0,
    D3D10_INPUT_PER_INSTANCE_DATA = 1
  );
  TD3D10InputClassification = D3D10_INPUT_CLASSIFICATION;

const
  D3D10_APPEND_ALIGNED_ELEMENT = $ffffffff;

type
  PD3D10_InputElementDesc = ^TD3D10_InputElementDesc;
  D3D10_INPUT_ELEMENT_DESC = record
    SemanticName: LPCSTR;
    SemanticIndex: UINT;
    Format: DXGI_FORMAT;
    InputSlot: UINT;
    AlignedByteOffset: UINT;
    InputSlotClass: D3D10_INPUT_CLASSIFICATION;
    InstanceDataStepRate: UINT;
  end;
  TD3D10_InputElementDesc = D3D10_INPUT_ELEMENT_DESC;

  D3D10_FILL_MODE = (
    D3D10_FILL_WIREFRAME = 2,
    D3D10_FILL_SOLID     = 3
  );
  TD3D10_FillMode = D3D10_FILL_MODE;

  D3D10_PRIMITIVE_TOPOLOGY = (
    D3D10_PRIMITIVE_TOPOLOGY_UNDEFINED         = 0,
    D3D10_PRIMITIVE_TOPOLOGY_POINTLIST         = 1,
    D3D10_PRIMITIVE_TOPOLOGY_LINELIST          = 2,
    D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP         = 3,
    D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST      = 4,
    D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP     = 5,
    D3D10_PRIMITIVE_TOPOLOGY_LINELIST_ADJ      = 10,
    D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ     = 11,
    D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ  = 12,
    D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ = 13
  );
  TD3D10_PrimitiveTopology = D3D10_PRIMITIVE_TOPOLOGY;

  D3D10_PRIMITIVE = (
    D3D10_PRIMITIVE_UNDEFINED	= 0,
    D3D10_PRIMITIVE_POINT	= 1,
    D3D10_PRIMITIVE_LINE	= 2,
    D3D10_PRIMITIVE_TRIANGLE	= 3,
    D3D10_PRIMITIVE_LINE_ADJ	= 6,
    D3D10_PRIMITIVE_TRIANGLE_ADJ	= 7
  );
  TD3D10_Primitive = D3D10_PRIMITIVE;

  D3D10_CULL_MODE = (
    D3D10_CULL_NONE  = 1,
    D3D10_CULL_FRONT = 2,
    D3D10_CULL_BACK  = 3
  );
  TD3D10_CullMode = D3D10_CULL_MODE;

  PD3D10_SO_DeclarationEntry = ^TD3D10_SO_DeclarationEntry;
  D3D10_SO_DECLARATION_ENTRY = record
    SemanticName: LPCSTR;
    SemanticIndex: UINT;
    StartComponent: Byte;
    ComponentCount: Byte;
    OutputSlot: Byte;
  end;
  TD3D10_SO_DeclarationEntry = D3D10_SO_DECLARATION_ENTRY;

  PD3D10_Viewport = ^TD3D10_Viewport;
  D3D10_VIEWPORT = record
    TopLeftX: Longint;
    TopLeftY: Longint;
    Width: UINT;
    Height: UINT;
    MinDepth: Single;
    MaxDepth: Single;
  end;
  TD3D10_Viewport = D3D10_VIEWPORT;

  PD3D10_ResourceDimension = ^TD3D10_ResourceDimension;
  D3D10_RESOURCE_DIMENSION = (
    D3D10_RESOURCE_DIMENSION_UNKNOWN{ = 0},
    D3D10_RESOURCE_DIMENSION_BUFFER{ = 1},
    D3D10_RESOURCE_DIMENSION_TEXTURE1D{ = 2},
    D3D10_RESOURCE_DIMENSION_TEXTURE2D{ = 3},
    D3D10_RESOURCE_DIMENSION_TEXTURE3D{ = 4}
  );
  TD3D10_ResourceDimension = D3D10_RESOURCE_DIMENSION;

  PD3D10_SRV_Dimension = ^TD3D10_SRV_Dimension;
  D3D10_SRV_DIMENSION = (
    D3D10_SRV_DIMENSION_UNKNOWN{ = 0},
    D3D10_SRV_DIMENSION_BUFFER{= 1},
    D3D10_SRV_DIMENSION_TEXTURE1D{ = 2},
    D3D10_SRV_DIMENSION_TEXTURE1DARRAY{ = 3},
    D3D10_SRV_DIMENSION_TEXTURE2D{ = 4},
    D3D10_SRV_DIMENSION_TEXTURE2DARRAY{ = 5},
    D3D10_SRV_DIMENSION_TEXTURE2DMS{ = 6},
    D3D10_SRV_DIMENSION_TEXTURE2DMSARRAY{ = 7},
    D3D10_SRV_DIMENSION_TEXTURE3D{ = 8},
    D3D10_SRV_DIMENSION_TEXTURECUBE{ = 9}
  );
  TD3D10_SRV_Dimension = D3D10_SRV_DIMENSION;

  PD3D10_DSV_Dimension = ^TD3D10_DSV_Dimension;
  D3D10_DSV_DIMENSION = (
    D3D10_DSV_DIMENSION_UNKNOWN{ = 0},
    D3D10_DSV_DIMENSION_TEXTURE1D{ = 1},
    D3D10_DSV_DIMENSION_TEXTURE1DARRAY{ = 2},
    D3D10_DSV_DIMENSION_TEXTURE2D{ = 3},
    D3D10_DSV_DIMENSION_TEXTURE2DARRAY{ = 4},
    D3D10_DSV_DIMENSION_TEXTURE2DMS{ = 5},
    D3D10_DSV_DIMENSION_TEXTURE2DMSARRAY{ = 6}
  );
  TD3D10_DSV_Dimension = D3D10_DSV_DIMENSION;

  PD3D10_RTV_Dimension = ^TD3D10_RTV_Dimension;
  D3D10_RTV_DIMENSION = (
    D3D10_RTV_DIMENSION_UNKNOWN{ = 0},
    D3D10_RTV_DIMENSION_BUFFER{ = 1},
    D3D10_RTV_DIMENSION_TEXTURE1D{ = 2},
    D3D10_RTV_DIMENSION_TEXTURE1DARRAY{ = 3},
    D3D10_RTV_DIMENSION_TEXTURE2D{ = 4},
    D3D10_RTV_DIMENSION_TEXTURE2DARRAY{ = 5},
    D3D10_RTV_DIMENSION_TEXTURE2DMS{ = 6},
    D3D10_RTV_DIMENSION_TEXTURE2DMSARRAY{ = 7},
    D3D10_RTV_DIMENSION_TEXTURE3D{ = 8}
  );
  TD3D10_RTV_Dimension = D3D10_RTV_DIMENSION;

  D3D10_USAGE = (
    D3D10_USAGE_DEFAULT{ = 0},
    D3D10_USAGE_IMMUTABLE{ = 1},
    D3D10_USAGE_DYNAMIC{ = 2},
    D3D10_USAGE_STAGING{ = 3}
  );
  TD3D10_Usage = D3D10_USAGE;

  D3D10_BIND_FLAG = UINT;
  TD3D10_BindFlag = D3D10_BIND_FLAG;
const
  D3D10_BIND_VERTEX_BUFFER   = $1;
  D3D10_BIND_INDEX_BUFFER    = $2;
  D3D10_BIND_CONSTANT_BUFFER = $4;
  D3D10_BIND_SHADER_RESOURCE = $8;
  D3D10_BIND_STREAM_OUTPUT   = $10;
  D3D10_BIND_RENDER_TARGET   = $20;
  D3D10_BIND_DEPTH_STENCIL   = $40;

type
  D3D10_CPU_ACCESS_FLAG = UINT;
  TD3D10_CpuAccessFlag = D3D10_CPU_ACCESS_FLAG;
const
  D3D10_CPU_ACCESS_WRITE = $10000;
  D3D10_CPU_ACCESS_READ  = $20000;

type
  D3D10_RESOURCE_MISC_FLAG = UINT;
  TD3D10_RresourceMiscFlag = D3D10_RESOURCE_MISC_FLAG;
const
  D3D10_RESOURCE_MISC_GENERATE_MIPS    = $1;
  D3D10_RESOURCE_MISC_SHARED	         = $2;
  D3D10_RESOURCE_MISC_TEXTURECUBE	     = $4;
	D3D10_RESOURCE_MISC_SHARED_KEYEDMUTEX	= $10;
	D3D10_RESOURCE_MISC_GDI_COMPATIBLE   = $20;

type
  D3D10_MAP = (
    D3D10_MAP_READ = 1,
    D3D10_MAP_WRITE = 2,
    D3D10_MAP_READ_WRITE = 3,
    D3D10_MAP_WRITE_DISCARD = 4,
    D3D10_MAP_WRITE_NO_OVERWRITE = 5
  );
  TD3D10_Map = D3D10_MAP;

  D3D10_MAP_FLAG = (
    D3D10_MAP_FLAG_DO_NOT_WAIT = $100000
  );
  TD3D10_MapFlag = D3D10_MAP_FLAG;

  D3D10_RAISE_FLAG = (
    D3D10_RAISE_FLAG_DRIVER_INTERNAL_ERROR = $1
  );
  TD3D10_RaiseFlag = D3D10_RAISE_FLAG;

type
  D3D10_CLEAR_FLAG = UINT;
  TD3D10_ClearFlag = D3D10_CLEAR_FLAG;

const
  D3D10_CLEAR_DEPTH     = TD3D10_ClearFlag($1);
  D3D10_CLEAR_STENCIL   = TD3D10_ClearFlag($2);

type
  D3D10_RECT = TRect;
  TD3D10_Rect = TRect;
  PD3D10_Rect = ^TD3D10_Rect;

  PD3D10_Box = ^TD3D10_Box;
  D3D10_BOX = record
    left: UINT;
    top: UINT;
    front: UINT;
    right: UINT;
    bottom: UINT;
    back: UINT;
  end;
  TD3D10_Box = D3D10_BOX;


type
  D3D10_FORMAT_SUPPORT = UINT;
  TD3D10_FormatSupport = D3D10_FORMAT_SUPPORT;

const
  D3D10_FORMAT_SUPPORT_BUFFER                     = $1;
  D3D10_FORMAT_SUPPORT_IA_VERTEX_BUFFER           = $2;
  D3D10_FORMAT_SUPPORT_IA_INDEX_BUFFER            = $4;
  D3D10_FORMAT_SUPPORT_SO_BUFFER                  = $8;
  D3D10_FORMAT_SUPPORT_TEXTURE1D                  = $10;
  D3D10_FORMAT_SUPPORT_TEXTURE2D                  = $20;
  D3D10_FORMAT_SUPPORT_TEXTURE3D                  = $40;
  D3D10_FORMAT_SUPPORT_TEXTURECUBE                = $80;
  D3D10_FORMAT_SUPPORT_SHADER_LOAD                = $100;
  D3D10_FORMAT_SUPPORT_SHADER_SAMPLE              = $200;
  D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_COMPARISON   = $400;
  D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_MONO_TEXT    = $800;
  D3D10_FORMAT_SUPPORT_MIP                        = $1000;
  D3D10_FORMAT_SUPPORT_MIP_AUTOGEN                = $2000;
  D3D10_FORMAT_SUPPORT_RENDER_TARGET              = $4000;
  D3D10_FORMAT_SUPPORT_BLENDABLE                  = $8000;
  D3D10_FORMAT_SUPPORT_DEPTH_STENCIL              = $10000;
  D3D10_FORMAT_SUPPORT_CPU_LOCKABLE               = $20000;
  D3D10_FORMAT_SUPPORT_MULTISAMPLE_RESOLVE        = $40000;
  D3D10_FORMAT_SUPPORT_DISPLAY                    = $80000;
  D3D10_FORMAT_SUPPORT_CAST_WITHIN_BIT_LAYOUT     = $100000;
  D3D10_FORMAT_SUPPORT_MULTISAMPLE_RENDERTARGET	  = $200000;
  D3D10_FORMAT_SUPPORT_MULTISAMPLE_LOAD	          = $400000;
  D3D10_FORMAT_SUPPORT_SHADER_GATHER              = $800000;
	D3D10_FORMAT_SUPPORT_BACK_BUFFER_CAST	          = $1000000;


type
  ID3D10DeviceChild = interface;
  ID3D10DepthStencilState = interface;
  ID3D10BlendState = interface;
  ID3D10RasterizerState = interface;
  ID3D10Resource = interface;
  ID3D10Buffer = interface;
  ID3D10Texture1D = interface;
  ID3D10Texture2D = interface;
  ID3D10Texture3D = interface;
  ID3D10View = interface;
  ID3D10ShaderResourceView = interface;
  ID3D10RenderTargetView = interface;
  ID3D10DepthStencilView = interface;
  ID3D10VertexShader = interface;
  ID3D10GeometryShader = interface;
  ID3D10PixelShader = interface;
  ID3D10InputLayout = interface;
  ID3D10SamplerState = interface;
  ID3D10Asynchronous = interface;
  ID3D10Query = interface;
  ID3D10Predicate = interface;
  ID3D10Counter = interface;
  ID3D10Device = interface;
  ID3D10Multithread = interface;


  PID3D10DeviceChild = ^ID3D10DeviceChild;
  PID3D10DepthStencilState = ^ID3D10DepthStencilState;
  PID3D10BlendState = ^ID3D10BlendState;
  PID3D10RasterizerState = ^ID3D10RasterizerState;
  PID3D10Resource = ^ID3D10Resource;
  PID3D10Buffer = ^ID3D10Buffer;
  PID3D10Texture1D = ^ID3D10Texture1D;
  PID3D10Texture2D = ^ID3D10Texture2D;
  PID3D10Texture3D = ^ID3D10Texture3D;
  PID3D10View = ^ID3D10View;
  PID3D10ShaderResourceView = ^ID3D10ShaderResourceView;
  PID3D10RenderTargetView = ^ID3D10RenderTargetView;
  PID3D10DepthStencilView = ^ID3D10DepthStencilView;
  PID3D10VertexShader = ^ID3D10VertexShader;
  PID3D10GeometryShader = ^ID3D10GeometryShader;
  PID3D10PixelShader = ^ID3D10PixelShader;
  PID3D10InputLayout = ^ID3D10InputLayout;
  PID3D10SamplerState = ^ID3D10SamplerState;
  PID3D10Asynchronous = ^ID3D10Asynchronous;
  PID3D10Query = ^ID3D10Query;
  PID3D10Predicate = ^ID3D10Predicate;
  PID3D10Counter = ^ID3D10Counter;
  PID3D10Device = ^ID3D10Device;
  PID3D10Multithread = ^ID3D10Multithread;


  ID3D10DeviceChild = interface (IUnknown)
    ['{9B7E4C00-342C-4106-A19F-4F2704F689F0}']
    procedure GetDevice(out ppDevice: ID3D10Device); stdcall;

    function GetPrivateData(
            (* __in *) const guid: TGUID;
            (* __inout *) var pDataSize: UINT;
            (* __out_bcount_opt(*pDataSize) *) pData: Pointer): HResult; stdcall;

    function SetPrivateData(
            (* __in *) const guid: TGUID;
            (* __in *) DataSize: UINT;
            (* __in_bcount_opt(DataSize) *) pData: Pointer): HResult; stdcall;

    function SetPrivateDataInterface(
            (* __in *) const guid: TGUID;
            (* __in_opt *) const pData: IUnknown): HResult; stdcall;
  end;

  IID_ID3D10DeviceChild = ID3D10DeviceChild;



  D3D10_COMPARISON_FUNC = (
    D3D10_COMPARISON_NEVER         = 1,
    D3D10_COMPARISON_LESS          = 2,
    D3D10_COMPARISON_EQUAL         = 3,
    D3D10_COMPARISON_LESS_EQUAL    = 4,
    D3D10_COMPARISON_GREATER       = 5,
    D3D10_COMPARISON_NOT_EQUAL     = 6,
    D3D10_COMPARISON_GREATER_EQUAL = 7,
    D3D10_COMPARISON_ALWAYS        = 8
  );
  TD3D10_ComparisonFunc = D3D10_COMPARISON_FUNC;

  D3D10_DEPTH_WRITE_MASK = (
    D3D10_DEPTH_WRITE_MASK_ZERO = 0,
    D3D10_DEPTH_WRITE_MASK_ALL  = 1
  );
  TD3D10_DepthWriteMask  = D3D10_DEPTH_WRITE_MASK;

  D3D10_STENCIL_OP = (
    D3D10_STENCIL_OP_KEEP     = 1,
    D3D10_STENCIL_OP_ZERO     = 2,
    D3D10_STENCIL_OP_REPLACE  = 3,
    D3D10_STENCIL_OP_INCR_SAT = 4,
    D3D10_STENCIL_OP_DECR_SAT = 5,
    D3D10_STENCIL_OP_INVERT   = 6,
    D3D10_STENCIL_OP_INCR     = 7,
    D3D10_STENCIL_OP_DECR     = 8
  );
  TD3D10_StencilOp = D3D10_STENCIL_OP;

  D3D10_DEPTH_STENCILOP_DESC = record
    StencilFailOp: TD3D10_StencilOp;
    StencilDepthFailOp: TD3D10_StencilOp;
    StencilPassOp: TD3D10_StencilOp;
    StencilFunc: TD3D10_ComparisonFunc;
  end;
  TD3D10_DepthStencilOpDesc = D3D10_DEPTH_STENCILOP_DESC;

  D3D10_DEPTH_STENCIL_DESC = record
    DepthEnable: BOOL;
    DepthWriteMask: TD3D10_DepthWriteMask;
    DepthFunc: TD3D10_ComparisonFunc;
    StencilEnable: BOOL;
    StencilReadMask: Byte;
    StencilWriteMask: Byte;
    FrontFace: TD3D10_DepthStencilOpDesc;
    BackFace: TD3D10_DepthStencilOpDesc;
  end;
  TD3D10_DepthStencilDesc = D3D10_DEPTH_STENCIL_DESC;



  ID3D10DepthStencilState = interface (ID3D10DeviceChild)
    ['{2B4B1CC8-A4AD-41f8-8322-CA86FC3EC675}']
    procedure GetDesc(out pDesc: TD3D10_DepthStencilDesc); stdcall;
  end;

  IID_ID3D10DepthStencilState = ID3D10DepthStencilState;

  PD3D10_Blend = ^TD3D10_Blend;
  D3D10_BLEND = (
    D3D10_BLEND_ZERO             = 1,
    D3D10_BLEND_ONE              = 2,
    D3D10_BLEND_SRC_COLOR        = 3,
    D3D10_BLEND_INV_SRC_COLOR    = 4,
    D3D10_BLEND_SRC_ALPHA        = 5,
    D3D10_BLEND_INV_SRC_ALPHA    = 6,
    D3D10_BLEND_DEST_ALPHA       = 7,
    D3D10_BLEND_INV_DEST_ALPHA   = 8,
    D3D10_BLEND_DEST_COLOR       = 9,
    D3D10_BLEND_INV_DEST_COLOR   = 10,
    D3D10_BLEND_SRC_ALPHA_SAT    = 11,
    D3D10_BLEND_BLEND_FACTOR     = 14,
    D3D10_BLEND_INV_BLEND_FACTOR = 15,
    D3D10_BLEND_SRC1_COLOR       = 16,
    D3D10_BLEND_INV_SRC1_COLOR   = 17,
    D3D10_BLEND_SRC1_ALPHA       = 18,
    D3D10_BLEND_INV_SRC1_ALPHA   = 19
  );
  TD3D10_Blend = D3D10_BLEND;

  D3D10_BLEND_OP = (
    D3D10_BLEND_OP_ADD          = 1,
    D3D10_BLEND_OP_SUBTRACT     = 2,
    D3D10_BLEND_OP_REV_SUBTRACT = 3,
    D3D10_BLEND_OP_MIN          = 4,
    D3D10_BLEND_OP_MAX          = 5
  );
  TD3D10_BlendOp = D3D10_BLEND_OP;

  D3D10_COLOR_WRITE_ENABLE = (
    D3D10_COLOR_WRITE_ENABLE_RED   = 1,
    D3D10_COLOR_WRITE_ENABLE_GREEN = 2,
    D3D10_COLOR_WRITE_ENABLE_BLUE  = 4,
    D3D10_COLOR_WRITE_ENABLE_ALPHA = 8,
    D3D10_COLOR_WRITE_ENABLE_ALL   = D3D10_COLOR_WRITE_ENABLE_RED +
                                     D3D10_COLOR_WRITE_ENABLE_GREEN +
                                     D3D10_COLOR_WRITE_ENABLE_BLUE +
                                     D3D10_COLOR_WRITE_ENABLE_ALPHA
  );
  TD3D10_ColorWriteEnable = D3D10_COLOR_WRITE_ENABLE;

  D3D10_BLEND_DESC = record
    AlphaToCoverageEnable: BOOL;
    BlendEnable: array[0..7] of BOOL;
    SrcBlend: TD3D10_Blend;
    DestBlend: TD3D10_Blend;
    BlendOp: TD3D10_BlendOp;
    SrcBlendAlpha: TD3D10_Blend;
    DestBlendAlpha: TD3D10_Blend;
    BlendOpAlpha: TD3D10_Blend;
    RenderTargetWriteMask: array[0..7] of Byte;
  end;
  TD3D10_BlendDesc = D3D10_BLEND_DESC;


  ID3D10BlendState = interface (ID3D10DeviceChild)
    ['{EDAD8D19-8A35-4d6d-8566-2EA276CDE161}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_BlendDesc); stdcall;
  end;

  IID_ID3D10BlendState = ID3D10BlendState;


  D3D10_RASTERIZER_DESC = record
    FillMode: TD3D10_FillMode;
    CullMode: TD3D10_CullMode;
    FrontCounterClockwise: BOOL;
    DepthBias: Longint;
    DepthBiasClamp: Single;
    SlopeScaledDepthBias: Single;
    DepthClipEnable: BOOL;
    ScissorEnable: BOOL;
    MultisampleEnable: BOOL;
    AntialiasedLineEnable: BOOL;
  end;
  TD3D10_RasterizerDesc = D3D10_RASTERIZER_DESC;


  ID3D10RasterizerState = interface (ID3D10DeviceChild)
    ['{A2A07292-89AF-4345-BE2E-C53D9FBB6E9F}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_RasterizerDesc); stdcall;
  end;

  IID_ID3D10RasterizerState = ID3D10RasterizerState;


  PD3D10_SubresourceData = ^TD3D10_SubresourceData;
  D3D10_SUBRESOURCE_DATA = record
    pSysMem: {const} Pointer;
    SysMemPitch: UINT;
    SysMemSlicePitch: UINT;
  end;
  TD3D10_SubresourceData = D3D10_SUBRESOURCE_DATA;


  ID3D10Resource = interface (ID3D10DeviceChild)
    ['{9B7E4C01-342C-4106-A19F-4F2704F689F0}']
    function GetType(
            (* [out] *) out rType: TD3D10_ResourceDimension): HResult; stdcall;

    function SetEvictionPriority(
            (* [in] *) EvictionPriority: UINT): HResult; stdcall;

    function GetEvictionPriority(): UINT; stdcall;
  end;

  IID_ID3D10Resource = ID3D10Resource;


  D3D10_BUFFER_DESC = record
    ByteWidth: UINT;
    Usage: TD3D10_Usage;
    BindFlags: TD3D10_BindFlag; //Clootie: changed from UINT;
    CPUAccessFlags: TD3D10_CpuAccessFlag; //Clootie: changed from UINT;
    MiscFlags: UINT;
  end;

  TD3D10_BufferDesc = D3D10_BUFFER_DESC;




  ID3D10Buffer = interface (ID3D10Resource)
    ['{9B7E4C02-342C-4106-A19F-4F2704F689F0}']
    function Map(
            (* [in] *) MapType: TD3D10_Map;
            (* [in] *) MapFlags: UINT;
            (* [out] *) out ppData: Pointer): HResult; stdcall;

    procedure Unmap(); stdcall;

    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_BufferDesc); stdcall;
  end;

  IID_ID3D10Buffer = ID3D10Buffer;


  D3D10_TEXTURE1D_DESC = record
    Width: UINT;
    MipLevels: UINT;
    ArraySize: UINT;
    Format: DXGI_FORMAT;
    Usage: D3D10_USAGE;
    BindFlags: UINT;
    CPUAccessFlags: UINT;
    MiscFlags: UINT;
  end;
  TD3D10_Texture1DDesc = D3D10_TEXTURE1D_DESC;

  ID3D10Texture1D = interface (ID3D10Resource)
    ['{9B7E4C03-342C-4106-A19F-4F2704F689F0}']

    function Map(
            (* [in] *) Subresource: UINT;
            (* [in] *) MapType: TD3D10_Map;
            (* [in] *) MapFlags: UINT;
            (* [out] *) out ppData: Pointer): HResult; stdcall;

    procedure Unmap(
            (* [in] *) Subresource: UINT); stdcall;

    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_Texture1DDesc); stdcall;
  end;

  IID_ID3D10Texture1D = ID3D10Texture1D;

  D3D10_TEXTURE2D_DESC = record
    Width: UINT;
    Height: UINT;
    MipLevels: UINT;
    ArraySize: UINT;
    Format: DXGI_FORMAT;
    SampleDesc: DXGI_SAMPLE_DESC;
    Usage: TD3D10_Usage;
    BindFlags: UINT;
    CPUAccessFlags: UINT;
    MiscFlags: UINT;
  end;
  TD3D10_Texture2DDesc = D3D10_TEXTURE2D_DESC;

  D3D10_MAPPED_TEXTURE2D = record
    pData: Pointer;
    RowPitch: UINT;
  end;
  TD3D10_MappedTexture2D = D3D10_MAPPED_TEXTURE2D;

  ID3D10Texture2D = interface (ID3D10Resource)
    ['{9B7E4C04-342C-4106-A19F-4F2704F689F0}']
    function Map(
            (* [in] *) Subresource: UINT;
            (* [in] *) MapType: D3D10_MAP;
            (* [in] *) MapFlags: UINT;
            (* [out] *) out pMappedTex2D: TD3D10_MappedTexture2D): HResult; stdcall;

    procedure Unmap(
            (* [in] *) Subresource: UINT); stdcall;

    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_Texture2DDesc); stdcall;
  end;

  IID_ID3D10Texture2D = ID3D10Texture2D;

  D3D10_TEXTURE3D_DESC = record
    Width: UINT;
    Height: UINT;
    Depth: UINT;
    MipLevels: UINT;
    Format: DXGI_FORMAT;
    Usage: TD3D10_Usage;
    BindFlags: UINT;
    CPUAccessFlags: UINT;
    MiscFlags: UINT;
  end;
  TD3D10_Texture3DDesc = D3D10_TEXTURE3D_DESC;

  D3D10_MAPPED_TEXTURE3D = record
    pData: Pointer;
    RowPitch: UINT;
    DepthPitch: UINT;
  end;
  TD3D10_MappedTexture3D = D3D10_MAPPED_TEXTURE3D;

  ID3D10Texture3D = interface (ID3D10Resource)
    ['{9B7E4C05-342C-4106-A19F-4F2704F689F0}']
    function Map(
            (* [in] *) Subresource: UINT;
            (* [in] *) MapType: D3D10_MAP;
            (* [in] *) MapFlags: UINT;
            (* [out] *) out pMappedTex3D: TD3D10_MappedTexture2D): HResult; stdcall;

    procedure Unmap(
            (* [in] *) Subresource: UINT); stdcall;

    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_Texture3DDesc); stdcall;
  end;

  IID_ID3D10Texture3D = ID3D10Texture3D;

  D3D10_TEXTURECUBE_FACE = (
    D3D10_TEXTURECUBE_FACE_POSITIVE_X = 0,
    D3D10_TEXTURECUBE_FACE_NEGATIVE_X = 1,
    D3D10_TEXTURECUBE_FACE_POSITIVE_Y = 2,
    D3D10_TEXTURECUBE_FACE_NEGATIVE_Y = 3,
    D3D10_TEXTURECUBE_FACE_POSITIVE_Z = 4,
    D3D10_TEXTURECUBE_FACE_NEGATIVE_Z = 5
  );
  TD3D10_TextureCubeFace = D3D10_TEXTURECUBE_FACE;


  ID3D10View = interface (ID3D10DeviceChild)
    ['{C902B03F-60A7-49BA-9936-2A3AB37A7E33}']
    procedure GetResource(
            (* [retval][out] *) out ppResource: ID3D10Resource); stdcall;
  end;

  IID_ID3D10View = ID3D10View;


  D3D10_BUFFER_SRV = record
  case Byte of
    0: (
      ElementOffset: UINT;
      ElementWidth: UINT;
    );
   1: (
      FirstElement: UINT;
      NumElements: UINT;
    );
  end;
  TD3D10_Buffer_SRV = D3D10_BUFFER_SRV;

  D3D10_TEX1D_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
  end;
  TD3D10_Tex1D_SRV = D3D10_TEX1D_SRV;

  D3D10_TEX1D_ARRAY_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex1DArraySRV = D3D10_TEX1D_ARRAY_SRV;

  D3D10_TEX2D_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
  end;
  TD3D10_Tex2D_SRV = D3D10_TEX2D_SRV;

  D3D10_TEX2D_ARRAY_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex2DArraySRV = D3D10_TEX2D_ARRAY_SRV;

  D3D10_TEX3D_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
  end;
  TD3D10_Tex3D_SRV = D3D10_TEX3D_SRV;

  D3D10_TEXCUBE_SRV = record
    MostDetailedMip: UINT;
    MipLevels: UINT;
  end;
  TD3D10_TexCube_SRV = D3D10_TEXCUBE_SRV;

  D3D10_TEX2DMS_SRV = record
    UnusedField_NothingToDefine: UINT;
  end;
  TD3D10_Tex2DMS_SRV = D3D10_TEX2DMS_SRV;

  D3D10_TEX2DMS_ARRAY_SRV = record
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;

  PD3D10_ShaderResourceViewDesc = ^TD3D10_ShaderResourceViewDesc;
  D3D10_SHADER_RESOURCE_VIEW_DESC = record
    Format: DXGI_FORMAT;
    ViewDimension: D3D10_SRV_DIMENSION;
    case Byte of
      0: (Buffer: TD3D10_Buffer_SRV);
      1: (Texture1D: TD3D10_Tex1D_SRV);
      2: (Texture1DArray: D3D10_TEX1D_ARRAY_SRV);
      3: (Texture2D: TD3D10_Tex2D_SRV);
      4: (Texture2DArray: D3D10_TEX2D_ARRAY_SRV);
      5: (Texture2DMS: D3D10_TEX2DMS_SRV);
      6: (Texture2DMSArray: D3D10_TEX2DMS_ARRAY_SRV);
      7: (Texture3D: TD3D10_Tex3D_SRV);
      8: (TextureCube: TD3D10_TexCube_SRV);
  end;
  TD3D10_ShaderResourceViewDesc = D3D10_SHADER_RESOURCE_VIEW_DESC;


  ID3D10ShaderResourceView = interface (ID3D10View)
    ['{9B7E4C07-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_ShaderResourceViewDesc); stdcall;
  end;

  IID_ID3D10ShaderResourceView = ID3D10ShaderResourceView;


  D3D10_BUFFER_RTV = record
  case Byte of
    0: (
      ElementOffset: UINT;
      ElementWidth: UINT;
    );
   1: (
      FirstElement: UINT;
      NumElements: UINT;
    );
  end;
  TD3D10_Buffer_RTV = D3D10_BUFFER_RTV;

  D3D10_TEX1D_RTV = record
    MipSlice: UINT;
  end;
  TD3D10_Tex1D_RTV = D3D10_TEX1D_RTV;

  D3D10_TEX1D_ARRAY_RTV = record
    MipSlice: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex1DArray_RTV = D3D10_TEX1D_ARRAY_RTV;

  D3D10_TEX2D_RTV = record
    MipSlice: UINT;
  end;
  TD3D10_Tex2D_RTV = D3D10_TEX2D_RTV;

  D3D10_TEX2DMS_RTV = record
    UnusedField_NothingToDefine: UINT;
  end;
  TD3D10_Tex2DMS_RTV = D3D10_TEX2DMS_RTV;

  D3D10_TEX2D_ARRAY_RTV = record
    MipSlice: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex2DArray_RTV = D3D10_TEX2D_ARRAY_RTV;

  D3D10_TEX2DMS_ARRAY_RTV = record
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex2DMSArray_RTV = D3D10_TEX2DMS_ARRAY_RTV;

  D3D10_TEX3D_RTV = record
    MipSlice: UINT;
    FirstWSlice: UINT;
    WSize: UINT;
  end;
  TD3D10_Tex3D_RTV = D3D10_TEX3D_RTV;

  PD3D10_RenderTargetViewDesc = ^TD3D10_RenderTargetViewDesc;
  D3D10_RENDER_TARGET_VIEW_DESC = record
    Format: DXGI_FORMAT;
    ViewDimension: TD3D10_RTV_Dimension;
    case Byte of
      0: (Buffer: TD3D10_Buffer_RTV);
      1: (Texture1D: TD3D10_Tex1D_RTV);
      2: (Texture1DArray: TD3D10_Tex1DArray_RTV);
      3: (Texture2D: TD3D10_Tex2D_RTV);
      4: (Texture2DArray: TD3D10_Tex2DArray_RTV);
      5: (Texture2DMS: TD3D10_Tex2DMS_RTV);
      6: (Texture2DMSArray: TD3D10_Tex2DMSArray_RTV);
      7: (Texture3D: TD3D10_Tex3D_RTV);
  end;
  TD3D10_RenderTargetViewDesc = D3D10_RENDER_TARGET_VIEW_DESC;


  ID3D10RenderTargetView = interface (ID3D10View)
    ['{9B7E4C08-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_RenderTargetViewDesc); stdcall;
  end;

  IID_ID3D10RenderTargetView = ID3D10RenderTargetView;


  D3D10_TEX1D_DSV = record
    MipSlice: UINT;
  end;
  TD3D10_Tex1D_DSV = D3D10_TEX1D_DSV;

  D3D10_TEX1D_ARRAY_DSV = record
    MipSlice: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex1DArray_DSV = D3D10_TEX1D_ARRAY_DSV;

  D3D10_TEX2D_DSV = record
    MipSlice: UINT;
  end;
  TD3D10_Tex2D_DSV = D3D10_TEX2D_DSV;

  D3D10_TEX2D_ARRAY_DSV = record
    MipSlice: UINT;
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex2DArray_DSV = D3D10_TEX2D_ARRAY_DSV;

  D3D10_TEX2DMS_DSV = record
    UnusedField_NothingToDefine: UINT;
  end;
  TD3D10_Tex2DMS_DSV = D3D10_TEX2DMS_DSV;

  D3D10_TEX2DMS_ARRAY_DSV = record
    FirstArraySlice: UINT;
    ArraySize: UINT;
  end;
  TD3D10_Tex2DMSArray_DSV = D3D10_TEX2DMS_ARRAY_DSV;

  PD3D10_DepthStencilViewDesc = ^TD3D10_DepthStencilViewDesc;
  D3D10_DEPTH_STENCIL_VIEW_DESC = record
    Format: DXGI_FORMAT;
    ViewDimension: TD3D10_DSV_Dimension;
    case Byte of
      0: (Texture1D: TD3D10_Tex1D_DSV);
      1: (Texture1DArray: TD3D10_Tex1DArray_DSV);
      2: (Texture2D: TD3D10_Tex2D_DSV);
      3: (Texture2DArray: TD3D10_Tex2DArray_DSV);
      4: (Texture2DMS: TD3D10_Tex2DMS_DSV);
      5: (Texture2DMSArray: TD3D10_Tex2DMSArray_DSV);
  end;
  TD3D10_DepthStencilViewDesc = D3D10_DEPTH_STENCIL_VIEW_DESC;


  ID3D10DepthStencilView = interface (ID3D10View)
    ['{9B7E4C09-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_DepthStencilViewDesc); stdcall;
  end;

  IID_ID3D10DepthStencilView = ID3D10DepthStencilView;


  ID3D10VertexShader = interface (ID3D10DeviceChild)
    ['{9B7E4C0A-342C-4106-A19F-4F2704F689F0}']
  end;

  IID_ID3D10VertexShader = ID3D10VertexShader;


  ID3D10GeometryShader = interface (ID3D10DeviceChild)
    ['{6316BE88-54CD-4040-AB44-20461BC81F68}']
  end;

  IID_ID3D10GeometryShader = ID3D10GeometryShader;


  ID3D10PixelShader = interface (ID3D10DeviceChild)
    ['{4968B601-9D00-4cde-8346-8E7F675819B6}']
  end;

  IID_ID3D10PixelShader = ID3D10PixelShader;


  ID3D10InputLayout = interface (ID3D10DeviceChild)
    ['{9B7E4C0B-342C-4106-A19F-4F2704F689F0}']
  end;

  IID_ID3D10InputLayout = ID3D10InputLayout;


  D3D10_FILTER = (
    D3D10_FILTER_MIN_MAG_MIP_POINT = 0,
    D3D10_FILTER_MIN_MAG_POINT_MIP_LINEAR = $1,
    D3D10_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT = $4,
    D3D10_FILTER_MIN_POINT_MAG_MIP_LINEAR = $5,
    D3D10_FILTER_MIN_LINEAR_MAG_MIP_POINT = $10,
    D3D10_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR = $11,
    D3D10_FILTER_MIN_MAG_LINEAR_MIP_POINT = $14,
    D3D10_FILTER_MIN_MAG_MIP_LINEAR = $15,
    D3D10_FILTER_ANISOTROPIC = $55,
    D3D10_FILTER_COMPARISON_MIN_MAG_MIP_POINT = $80,
    D3D10_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR = $81,
    D3D10_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT = $84,
    D3D10_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR = $85,
    D3D10_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT = $90,
    D3D10_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR = $91,
    D3D10_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT = $94,
    D3D10_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR = $95,
    D3D10_FILTER_COMPARISON_ANISOTROPIC = $d5
    // D3D10_FILTER_TEXT_1BIT = $80000000

  );
  TD3D10_Filter = D3D10_FILTER;


{const
  D3D10_FILTER_TEXT_1BIT = D3D10_FILTER($80000000);}

  D3D10_FILTER_TYPE = (
    D3D10_FILTER_TYPE_POINT = 0,
    D3D10_FILTER_TYPE_LINEAR = 1
  );
  TD3D10_FilterType = D3D10_FILTER_TYPE;


{const
  D3D10_FILTER_TYPE_MASK = $3;

  D3D10_MIN_FILTER_SHIFT = 4;
  D3D10_MAG_FILTER_SHIFT = 2;
  D3D10_MIP_FILTER_SHIFT = 0;

  D3D10_COMPARISON_FILTERING_BIT = $80;

  D3D10_ANISOTROPIC_FILTERING_BIT = $40;

  D3D10_TEXT_1BIT_BIT = $80000000; }


{#define D3D10_ENCODE_BASIC_FILTER( min, mag, mip, bComparison )                                           \
                                   ( ( D3D10_FILTER ) (                                                   \
                                   ( ( bComparison ) ? D3D10_COMPARISON_FILTERING_BIT : 0 ) |             \
                                   ( ( ( min ) & D3D10_FILTER_TYPE_MASK ) << D3D10_MIN_FILTER_SHIFT ) |   \
                                   ( ( ( mag ) & D3D10_FILTER_TYPE_MASK ) << D3D10_MAG_FILTER_SHIFT ) |   \
                                   ( ( ( mip ) & D3D10_FILTER_TYPE_MASK ) << D3D10_MIP_FILTER_SHIFT ) ) )
#define D3D10_ENCODE_ANISOTROPIC_FILTER( bComparison )                                                \
                                         ( ( D3D10_FILTER ) (                                         \
                                         D3D10_ANISOTROPIC_FILTERING_BIT |                            \
                                         D3D10_ENCODE_BASIC_FILTER( D3D10_FILTER_TYPE_LINEAR,         \
                                                                    D3D10_FILTER_TYPE_LINEAR,         \
                                                                    D3D10_FILTER_TYPE_LINEAR,         \
                                                                    bComparison ) ) )
#define D3D10_DECODE_MIN_FILTER( d3d10Filter )                                                              \
                                 ( ( D3D10_FILTER_TYPE )                                                    \
                                 ( ( ( d3d10Filter ) >> D3D10_MIN_FILTER_SHIFT ) & D3D10_FILTER_TYPE_MASK ) )
#define D3D10_DECODE_MAG_FILTER( d3d10Filter )                                                              \
                                 ( ( D3D10_FILTER_TYPE )                                                    \
                                 ( ( ( d3d10Filter ) >> D3D10_MAG_FILTER_SHIFT ) & D3D10_FILTER_TYPE_MASK ) )
#define D3D10_DECODE_MIP_FILTER( d3d10Filter )                                                              \
                                 ( ( D3D10_FILTER_TYPE )                                                    \
                                 ( ( ( d3d10Filter ) >> D3D10_MIP_FILTER_SHIFT ) & D3D10_FILTER_TYPE_MASK ) )
#define D3D10_DECODE_IS_COMPARISON_FILTER( d3d10Filter )                                                    \
                                 ( ( d3d10Filter ) & D3D10_COMPARISON_FILTERING_BIT )
#define D3D10_DECODE_IS_ANISOTROPIC_FILTER( d3d10Filter )                                               \
                            ( ( ( d3d10Filter ) & D3D10_ANISOTROPIC_FILTERING_BIT ) &&                  \
                            ( D3D10_FILTER_TYPE_LINEAR == D3D10_DECODE_MIN_FILTER( d3d10Filter ) ) &&   \
                            ( D3D10_FILTER_TYPE_LINEAR == D3D10_DECODE_MAG_FILTER( d3d10Filter ) ) &&   \
                            ( D3D10_FILTER_TYPE_LINEAR == D3D10_DECODE_MIP_FILTER( d3d10Filter ) ) )
#define D3D10_DECODE_IS_TEXT_1BIT_FILTER( d3d10Filter )                                             \
                                 ( ( d3d10Filter ) == D3D10_TEXT_1BIT_BIT )
}

  D3D10_TEXTURE_ADDRESS_MODE = (
    D3D10_TEXTURE_ADDRESS_WRAP = 1,
    D3D10_TEXTURE_ADDRESS_MIRROR = 2,
    D3D10_TEXTURE_ADDRESS_CLAMP = 3,
    D3D10_TEXTURE_ADDRESS_BORDER = 4,
    D3D10_TEXTURE_ADDRESS_MIRROR_ONCE = 5
  );
  TD3D10_TextureAddressMode = D3D10_TEXTURE_ADDRESS_MODE;

  D3D10_SAMPLER_DESC = record
    Filter: D3D10_FILTER;
    AddressU: D3D10_TEXTURE_ADDRESS_MODE;
    AddressV: D3D10_TEXTURE_ADDRESS_MODE;
    AddressW: D3D10_TEXTURE_ADDRESS_MODE;
    MipLODBias: Single;
    MaxAnisotropy: UINT;
    ComparisonFunc: D3D10_COMPARISON_FUNC;
    BorderColor: array[0..3] of Single;
    MinLOD: Single;
    MaxLOD: Single;
  end;
  TD3D10_SamplerDesc = D3D10_SAMPLER_DESC;



  ID3D10SamplerState = interface (ID3D10DeviceChild)
    ['{9B7E4C0C-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* [retval][out] *) out pDesc: TD3D10_SamplerDesc); stdcall;
  end;

  IID_ID3D10SamplerState = ID3D10SamplerState;


  ID3D10Asynchronous = interface (ID3D10DeviceChild)
    ['{9B7E4C0D-342C-4106-A19F-4F2704F689F0}']
    procedure _Begin; stdcall;
    procedure _End; stdcall;

    function GetData(
            (* __out_bcount_opt(DataSize) *) pData: Pointer;
            (* [in] *) DataSize: UINT;
            (* [in] *) GetDataFlags: UINT): HResult; stdcall;

    function GetDataSize: UINT; stdcall;
  end;

  IID_ID3D10Asynchronous = ID3D10Asynchronous;


  D3D10_ASYNC_GETDATA_FLAG = (
    D3D10_ASYNC_GETDATA_DONOTFLUSH = $1
  );
  TD3D10_AsyncGetDataFlag = D3D10_ASYNC_GETDATA_FLAG;


  D3D10_QUERY = (
    D3D10_QUERY_EVENT = 0,
    D3D10_QUERY_OCCLUSION = (D3D10_QUERY_EVENT + 1),
    D3D10_QUERY_TIMESTAMP = (D3D10_QUERY_OCCLUSION + 1),
    D3D10_QUERY_TIMESTAMP_DISJOINT = (D3D10_QUERY_TIMESTAMP + 1),
    D3D10_QUERY_PIPELINE_STATISTICS = (D3D10_QUERY_TIMESTAMP_DISJOINT + 1),
    D3D10_QUERY_OCCLUSION_PREDICATE = (D3D10_QUERY_PIPELINE_STATISTICS + 1),
    D3D10_QUERY_SO_STATISTICS = (D3D10_QUERY_OCCLUSION_PREDICATE + 1),
    D3D10_QUERY_SO_OVERFLOW_PREDICATE = (D3D10_QUERY_SO_STATISTICS + 1)
  );
  TD3D10_Query = D3D10_QUERY;

  D3D10_QUERY_MISC_FLAG = (
    D3D10_QUERY_MISC_PREDICATEHINT = $1
  );
  TD3D10_QueryMiscFlag = D3D10_QUERY_MISC_FLAG;

  D3D10_QUERY_DESC = record
    Query: TD3D10_Query;
    MiscFlags: UINT;
  end;
  TD3D10_QueryDesc = D3D10_QUERY_DESC;


  ID3D10Query = interface (ID3D10Asynchronous)
    ['{9B7E4C0E-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* __out *) out pDesc: TD3D10_QueryDesc); stdcall;
  end;

  IID_ID3D10Query = ID3D10Query;


  ID3D10Predicate = interface (ID3D10Query)
    ['{9B7E4C10-342C-4106-A19F-4F2704F689F0}']
  end;

  IID_ID3D10Predicate = ID3D10Predicate;


  D3D10_QUERY_DATA_TIMESTAMP_DISJOINT = record
    Frequency: UINT64;
    Disjoint: BOOL;
  end;
  TD3D10_QueryData_Timestamp_Disjoint = D3D10_QUERY_DATA_TIMESTAMP_DISJOINT;

  D3D10_QUERY_DATA_PIPELINE_STATISTICS = record
    IAVertices: UINT64;
    IAPrimitives: UINT64;
    VSInvocations: UINT64;
    GSInvocations: UINT64;
    GSPrimitives: UINT64;
    CInvocations: UINT64;
    CPrimitives: UINT64;
    PSInvocations: UINT64;
  end;
  TD3D10_QueryData_Pipeline_Statistics = D3D10_QUERY_DATA_PIPELINE_STATISTICS;

  D3D10_QUERY_DATA_SO_STATISTICS = record
    NumPrimitivesWritten: UINT64;
    PrimitivesStorageNeeded: UINT64;
  end;
  TD3D10_QueryData_SO_Statistics  = D3D10_QUERY_DATA_SO_STATISTICS;

  D3D10_COUNTER = (
    D3D10_COUNTER_GPU_IDLE = 0,
    D3D10_COUNTER_VERTEX_PROCESSING = (D3D10_COUNTER_GPU_IDLE + 1),
    D3D10_COUNTER_GEOMETRY_PROCESSING = (D3D10_COUNTER_VERTEX_PROCESSING + 1),
    D3D10_COUNTER_PIXEL_PROCESSING = (D3D10_COUNTER_GEOMETRY_PROCESSING + 1),
    D3D10_COUNTER_OTHER_GPU_PROCESSING = (D3D10_COUNTER_PIXEL_PROCESSING + 1),
    D3D10_COUNTER_HOST_ADAPTER_BANDWIDTH_UTILIZATION = (D3D10_COUNTER_OTHER_GPU_PROCESSING + 1),
    D3D10_COUNTER_LOCAL_VIDMEM_BANDWIDTH_UTILIZATION = (D3D10_COUNTER_HOST_ADAPTER_BANDWIDTH_UTILIZATION + 1),
    D3D10_COUNTER_VERTEX_THROUGHPUT_UTILIZATION = (D3D10_COUNTER_LOCAL_VIDMEM_BANDWIDTH_UTILIZATION + 1),
    D3D10_COUNTER_TRIANGLE_SETUP_THROUGHPUT_UTILIZATION = (D3D10_COUNTER_VERTEX_THROUGHPUT_UTILIZATION + 1),
    D3D10_COUNTER_FILLRATE_THROUGHPUT_UTILIZATION = (D3D10_COUNTER_TRIANGLE_SETUP_THROUGHPUT_UTILIZATION + 1),
    D3D10_COUNTER_VS_MEMORY_LIMITED = (D3D10_COUNTER_FILLRATE_THROUGHPUT_UTILIZATION + 1),
    D3D10_COUNTER_VS_COMPUTATION_LIMITED = (D3D10_COUNTER_VS_MEMORY_LIMITED + 1),
    D3D10_COUNTER_GS_MEMORY_LIMITED = (D3D10_COUNTER_VS_COMPUTATION_LIMITED + 1),
    D3D10_COUNTER_GS_COMPUTATION_LIMITED = (D3D10_COUNTER_GS_MEMORY_LIMITED + 1),
    D3D10_COUNTER_PS_MEMORY_LIMITED = (D3D10_COUNTER_GS_COMPUTATION_LIMITED + 1),
    D3D10_COUNTER_PS_COMPUTATION_LIMITED = (D3D10_COUNTER_PS_MEMORY_LIMITED + 1),
    D3D10_COUNTER_POST_TRANSFORM_CACHE_HIT_RATE = (D3D10_COUNTER_PS_COMPUTATION_LIMITED + 1),
    D3D10_COUNTER_TEXTURE_CACHE_HIT_RATE = (D3D10_COUNTER_POST_TRANSFORM_CACHE_HIT_RATE + 1),
    D3D10_COUNTER_DEVICE_DEPENDENT_0 = $40000000
  );
  TD3D10_Counter = D3D10_COUNTER;

  D3D10_COUNTER_TYPE = (
    D3D10_COUNTER_TYPE_FLOAT32 = 0,
    D3D10_COUNTER_TYPE_UINT16 = (D3D10_COUNTER_TYPE_FLOAT32 + 1),
    D3D10_COUNTER_TYPE_UINT32 = (D3D10_COUNTER_TYPE_UINT16 + 1),
    D3D10_COUNTER_TYPE_UINT64 = (D3D10_COUNTER_TYPE_UINT32 + 1)
  );
  TD3D10_CounterType = D3D10_COUNTER_TYPE;

  D3D10_COUNTER_DESC = record
    Counter: TD3D10_Counter;
    MiscFlags: UINT;
  end;
  TD3D10_CounterDesc = D3D10_COUNTER_DESC;

  D3D10_COUNTER_INFO = record
    LastDeviceDependentCounter: TD3D10_Counter;
    NumSimultaneousCounters: UINT;
    NumDetectableParallelUnits: Byte;
  end;
  TD3D10_CounterInfo = D3D10_COUNTER_INFO;


  ID3D10Counter = interface (ID3D10Asynchronous)
    ['{9B7E4C11-342C-4106-A19F-4F2704F689F0}']
    procedure GetDesc(
            (* __out *)
            out pDesc: TD3D10_CounterDesc); stdcall;
  end;

  IID_ID3D10Counter = ID3D10Counter;


  PColorArray = ^TColorArray;
  TColorArray = array[0..3] of Single;

  ID3D10Device = interface (IUnknown)
    ['{9B7E4C0F-342C-4106-A19F-4F2704F689F0}']
    procedure VSSetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __in_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure PSSetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __in_ecount(NumViews) *)
            ppShaderResourceViews: PID3D10ShaderResourceView); stdcall;

    procedure PSSetShader(
            (* __in_opt *)
            pPixelShader: ID3D10PixelShader); stdcall;

    procedure PSSetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __in_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure VSSetShader(
            (* __in_opt *) pVertexShader: ID3D10VertexShader); stdcall;

    procedure DrawIndexed(
            (* __in *)
            IndexCount: UINT;
            (* __in *)
            StartIndexLocation: UINT;
            (* __in *)
            BaseVertexLocation: Integer); stdcall;

    procedure Draw(
            (* __in *)
            VertexCount: UINT;
            (* __in *)
            StartVertexLocation: UINT); stdcall;

    procedure PSSetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __in_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure IASetInputLayout(
            (* __in_opt *)
            pInputLayout: ID3D10InputLayout); stdcall;

    procedure IASetVertexBuffers(
            (* __in_range( 0, D3D10_1_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_1_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __in_ecount(NumBuffers) *)
            ppVertexBuffers: pID3D10Buffer;
            (* __in_ecount(NumBuffers) *)
            const pStrides: PLongWord;
            (* __in_ecount(NumBuffers) *)
            const pOffsets: PLongWord); stdcall;

    procedure IASetIndexBuffer(
            (* __in_opt *)
            pIndexBuffer: ID3D10Buffer;
            (* __in *)
            Format: DXGI_FORMAT;
            (* __in *)
            Offset: UINT); stdcall;

    procedure DrawIndexedInstanced(
            (* __in *)
            IndexCountPerInstance: UINT;
            (* __in *)
            InstanceCount: UINT;
            (* __in *)
            StartIndexLocation: UINT;
            (* __in *)
            BaseVertexLocation: Longint;
            (* __in *)
            StartInstanceLocation: UINT); stdcall;

    procedure DrawInstanced(
            (* [in] *) VertexCountPerInstance: UINT;
            (* [in] *) InstanceCount: UINT;
            (* [in] *) StartVertexLocation: UINT;
            (* [in] *) StartInstanceLocation: UINT); stdcall;

    procedure GSSetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __in_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure GSSetShader(
            (* __in_opt *)
            pShader: ID3D10GeometryShader); stdcall;

    procedure IASetPrimitiveTopology(
            (* __in *)
            Topology: TD3D10_PrimitiveTopology); stdcall;

    procedure VSSetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __in_ecount(NumViews) *)
            ppShaderResourceViews: ID3D10ShaderResourceView); stdcall;

    procedure VSSetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __in_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure SetPredication(
            (* __in_opt *)
            pPredicate: ID3D10Predicate;
            (* __in  *)
            PredicateValue: BOOL); stdcall;

    procedure GSSetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __in_ecount(NumViews) *)
            ppShaderResourceViews: PID3D10ShaderResourceView); stdcall;

    procedure GSSetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __in_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure OMSetRenderTargets(
            (* __in_range( 0, D3D10_SIMULTANEOUS_RENDER_TARGET_COUNT ) *)
            NumViews: UINT;
            (* __in_ecount_opt(NumViews) *)
            ppRenderTargetViews: PID3D10RenderTargetView;
            (* __in_opt *)
            pDepthStencilView: ID3D10DepthStencilView); stdcall;

    procedure OMSetBlendState(
            (* __in_opt *)
            pBlendState: ID3D10BlendState;
            (* __in *)
            const BlendFactor: TColorArray; // FLOAT BlendFactor[ 4 ],
            (* __in *)
            SampleMask: UINT); stdcall;

    procedure OMSetDepthStencilState(
            (* __in_opt *)
            pDepthStencilState: ID3D10DepthStencilState;
            (* __in *)
            StencilRef: UINT); stdcall;

    procedure SOSetTargets(
            (* __in_range( 0, D3D10_SO_BUFFER_SLOT_COUNT) *)
            NumBuffers: UINT;
            (* __in_ecount_opt(NumBuffers) *)
            ppSOTargets: PID3D10Buffer;
            (* __in_ecount_opt(NumBuffers) *)
            const pOffsets: PLongWord); stdcall;

    procedure DrawAuto(); stdcall;

    procedure RSSetState(
            (* __in_opt *)
            pRasterizerState: ID3D10RasterizerState); stdcall;

    procedure RSSetViewports(
            (* __in_range(0, D3D10_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE) *)
            NumViewports: UINT;
            (* __in_ecount_opt(NumViewports) *)
            const pViewports: PD3D10_Viewport); stdcall;

    procedure RSSetScissorRects(
            (* __in_range(0, D3D10_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE) *)
            NumRects: UINT;
            (* __in_ecount_opt(NumRects) *)
            const pRects: PD3D10_Rect); stdcall;

    procedure CopySubresourceRegion(
            (* __in *)
            pDstResource: ID3D10Resource;
            (* __in *)
            DstSubresource: UINT;
            (* __in *)
            DstX: UINT;
            (* __in *)
            DstY: UINT;
            (* __in *)
            DstZ: UINT;
            (* __in *)
            pSrcResource: ID3D10Resource;
            (* __in *)
            SrcSubresource: UINT;
            (* __in_opt *)
            const pSrcBox: PD3D10_Box); stdcall;

    procedure CopyResource(
            (* __in *)
            const pDstResource: ID3D10Resource;
            (* __in *)
            const pSrcResource: ID3D10Resource); stdcall;

    procedure UpdateSubresource(
            (* __in *)
            const pDstResource: ID3D10Resource;
            (* __in *)
            DstSubresource: UINT;
            (* __in_opt *)
            const pDstBox: PD3D10_Box;
            (* __in *)
            const pSrcData: Pointer;
            (* __in *)
            SrcRowPitch: UINT;
            (* __in *)
            SrcDepthPitch: UINT); stdcall;

    procedure ClearRenderTargetView(
            (* __in *)
            const pRenderTargetView: ID3D10RenderTargetView;
            (* __in *)
            const ColorRGBA: TColorArray); stdcall;

    procedure ClearDepthStencilView(
            (* __in *)
            const pDepthStencilView: ID3D10DepthStencilView;
            (* __in *)
            ClearFlags: TD3D10_ClearFlag; // UINT;
            (* __in *)
            Depth: Single;
            (* __in *)
            Stencil: Byte); stdcall;

    procedure GenerateMips(
            (* __in *)
            pShaderResourceView: ID3D10ShaderResourceView); stdcall;

    procedure ResolveSubresource(
            (* __in *)
            const pDstResource: ID3D10Resource;
            (* __in *)
            DstSubresource: UINT;
            (* __in *)
            const pSrcResource: ID3D10Resource;
            (* __in *)
            SrcSubresource: UINT;
            (* __in *)
            Format: DXGI_FORMAT); stdcall;

    procedure VSGetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __out_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure PSGetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __out_ecount(NumViews) *)
            ppShaderResourceViews: PID3D10ShaderResourceView); stdcall;

    procedure PSGetShader(
            (* __out *)
            out ppPixelShader: ID3D10PixelShader); stdcall;

    procedure PSGetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __out_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure VSGetShader(
            (* __out *)
            out ppVertexShader: ID3D10VertexShader); stdcall;

    procedure PSGetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __out_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure IAGetInputLayout(
            (* __out *)
            out ppInputLayout: ID3D10InputLayout); stdcall;

    procedure IAGetVertexBuffers(
            (* __in_range( 0, D3D10_1_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_1_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __out_ecount_opt(NumBuffers) *)
            ppVertexBuffers: PID3D10Buffer;
            (* __out_ecount_opt(NumBuffers) *)
            pStrides: PLongWord;
            (* __out_ecount_opt(NumBuffers) *)
            pOffsets: PLongWord); stdcall;

    procedure IAGetIndexBuffer(
            (* __out_opt *)
            pIndexBuffer: PID3D10Buffer;
            (* __out_opt *)
            Format: PDXGIFormat;
            (* __out_opt *)
            Offset: PLongWord); stdcall;

    procedure GSGetConstantBuffers(
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT - StartSlot ) *)
            NumBuffers: UINT;
            (* __out_ecount(NumBuffers) *)
            ppConstantBuffers: PID3D10Buffer); stdcall;

    procedure GSGetShader(
            (* __out *)
            out ppGeometryShader: ID3D10GeometryShader); stdcall;

    procedure IAGetPrimitiveTopology(
            (* __out *)
            out pTopology: TD3D10_PrimitiveTopology); stdcall;

    procedure VSGetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __out_ecount(NumViews) *)
            ppShaderResourceViews: PID3D10ShaderResourceView); stdcall;

    procedure VSGetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __out_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure GetPredication(
            (* __out_opt *)
            ppPredicate: PID3D10Predicate;
            (* __out_opt *)
            pPredicateValue: PBOOL); stdcall;

    procedure GSGetShaderResources(
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT - StartSlot ) *)
            NumViews: UINT;
            (* __out_ecount(NumViews) *)
            ppShaderResourceViews: PID3D10ShaderResourceView); stdcall;

    procedure GSGetSamplers(
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - 1 ) *)
            StartSlot: UINT;
            (* __in_range( 0, D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT - StartSlot ) *)
            NumSamplers: UINT;
            (* __out_ecount(NumSamplers) *)
            ppSamplers: PID3D10SamplerState); stdcall;

    procedure OMGetRenderTargets(
            (* __in_range( 0, D3D10_SIMULTANEOUS_RENDER_TARGET_COUNT ) *)
            NumViews: UINT;
            (* __out_ecount_opt(NumViews) *)
            ppRenderTargetViews: PID3D10RenderTargetView;
            (* __out_opt *)
            ppDepthStencilView: PID3D10DepthStencilView); stdcall;

    procedure OMGetBlendState(
            (* __out_opt *)
            ppBlendState: PID3D10BlendState;
            (* __out_opt *)
            BlendFactor: PColorArray;
            (* __out_opt *)
            pSampleMask: PLongWord); stdcall;

    procedure OMGetDepthStencilState(
            (* __out_opt *)
            ppDepthStencilState: PID3D10DepthStencilState;
            (* __out_opt *)
            pStencilRef: PLongWord); stdcall;

    procedure SOGetTargets(
            (* __in_range( 0, D3D10_SO_BUFFER_SLOT_COUNT ) *)
            NumBuffers: UINT;
            (* __out_ecount_opt(NumBuffers) *)
            ppSOTargets: PID3D10Buffer;
            (* __out_ecount_opt(NumBuffers) *)
            pOffsets: PLongWord); stdcall;

    procedure RSGetState(
            (* __out *)
            out ppRasterizerState: ID3D10RasterizerState); stdcall;

    procedure RSGetViewports(
            (* __inout ( *_range(0, D3D10_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE )* )  *)
            var NumViewports: UINT;
            (* __out_ecount_opt(*NumViewports) *)
            pViewports: PD3D10_Viewport); stdcall;

    procedure RSGetScissorRects(
            (* __inout ( *_range(0, D3D10_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE )* )  *)
            var NumRects: UINT;
            (* __out_ecount_opt(*NumRects) *)
            pRects: PD3D10_Rect); stdcall;

    function GetDeviceRemovedReason(): HResult; stdcall;

    function SetExceptionMode(RaiseFlags: UINT): HResult; stdcall;

    function GetExceptionMode(): UINT; stdcall;

    function GetPrivateData(
            (* __in *)
            guid: TGUID;
            (* __inout *)
            var pDataSize: UINT;
            (* __out_bcount_opt(*pDataSize) *)
            pData: Pointer): HResult; stdcall;

    function SetPrivateData(
            (* __in *)
            guid: TGUID;
            (* __in *)
            DataSize: UINT;
            (* __in_bcount_opt(DataSize) *)
            const pData: Pointer): HResult; stdcall;

    function SetPrivateDataInterface(
            (* __in *)
            guid: TGUID;
            (* __in_opt *)
            const pData: IUnknown): HResult; stdcall;

    procedure ClearState(); stdcall;

    procedure Flush(); stdcall;

    function CreateBuffer(
            (* __in *)
            const pDesc: TD3D10_BufferDesc;
            (* __in_opt *)
            const pInitialData: PD3D10_SubresourceData;
            (* __out_opt *)
            ppBuffer: PID3D10Buffer): HResult; stdcall;

    function CreateTexture1D(
            (* __in *)
            const pDesc: TD3D10_Texture1DDesc;
            (* __in_xcount_opt(pDesc.MipLevels * pDesc.ArraySize) *)
            const pInitialData: PD3D10_SubresourceData;
            (* __out *)
            out ppTexture1D: ID3D10Texture1D): HResult; stdcall;

    function CreateTexture2D(
            (* __in *)
            const pDesc: TD3D10_Texture2DDesc;
            (* __in_xcount_opt(pDesc.MipLevels * pDesc.ArraySize) *)
            const pInitialData: PD3D10_SubresourceData;
            (* __out *)
            out ppTexture2D: ID3D10Texture2D): HResult; stdcall;

    function CreateTexture3D(
            (* __in *)
            const pDesc: TD3D10_Texture3DDesc;
            (* __in_xcount_opt(pDesc.MipLevels) *)
            const pInitialData: PD3D10_SubresourceData;
            (* __out *)
            out ppTexture3D: ID3D10Texture3D): HResult; stdcall;

    function CreateShaderResourceView(
            (* __in *)
            const pResource: ID3D10Resource;
            (* __in_opt *)
            pDesc: PD3D10_ShaderResourceViewDesc;
            (* __out_opt *)
            ppSRView: PID3D10ShaderResourceView): HResult; stdcall;

    function CreateRenderTargetView(
            (* __in *)
            const pResource: ID3D10Resource;
            (* __in_opt *)
            const pDesc: PD3D10_RenderTargetViewDesc;
            (* __out_opt *)
            ppRTView: PID3D10RenderTargetView): HResult; stdcall;

    function CreateDepthStencilView(
            (* __in *)
            const pResource: ID3D10Resource;
            (* __in_opt *)
            const pDesc: PD3D10_DepthStencilViewDesc;
            (* __out_opt *)
            ppDepthStencilView: PID3D10DepthStencilView): HResult; stdcall;

    function CreateInputLayout(
            (* __in_ecount(NumElements) *)
            const pInputElementDescs: PD3D10_InputElementDesc;
            (* __in_range( 0, D3D10_1_IA_VERTEX_INPUT_STRUCTURE_ELEMENT_COUNT ) *)
            NumElements: UINT;
            (* __in *)
            const pShaderBytecodeWithInputSignature: Pointer;
            (* __in *)
            BytecodeLength: SIZE_T;
            (* __out_opt *)
            ppInputLayout: PID3D10InputLayout): HResult; stdcall;

    function CreateVertexShader(
            (* __in *)
            const pShaderBytecode: Pointer;
            (* __in *)
            BytecodeLength: SIZE_T;
            (* __out_opt *)
            ppVertexShader: PID3D10VertexShader): HResult; stdcall;

    function CreateGeometryShader(
            (* __in *)
            const pShaderBytecode: Pointer;
            (* __in *)
            BytecodeLength: SIZE_T;
            (* __out_opt *)
            ppGeometryShader: PID3D10GeometryShader): HResult; stdcall;

    function CreateGeometryShaderWithStreamOutput(
            (* __in *)
            const pShaderBytecode: Pointer;
            (* __in *)
            BytecodeLength: SIZE_T;
            (* __in_ecount_opt(NumEntries) *)
            const pSODeclaration: PD3D10_SO_DeclarationEntry;
            (* __in_range( 0, D3D10_SO_SINGLE_BUFFER_COMPONENT_LIMIT ) *)
            NumEntries: UINT;
            (* __in *)
            OutputStreamStride: UINT;
            (* __out_opt *)
            ppGeometryShader: PID3D10GeometryShader): HResult; stdcall;

    function CreatePixelShader(
            (* __in   *)
            const pShaderBytecode: Pointer;
            (* __in *)
            BytecodeLength: SIZE_T;
            (* __out_opt *)
            ppPixelShader: PID3D10PixelShader): HResult; stdcall;

    function CreateBlendState(
            (* __in *)
            const pBlendStateDesc: TD3D10_BlendDesc;
            (* __out_opt *)
            ppBlendState: PID3D10BlendState): HResult; stdcall;

    function CreateDepthStencilState(
            (* __in *)
            const pDepthStencilDesc: TD3D10_DepthStencilDesc;
            (* __out_opt *)
            ppDepthStencilState: PID3D10DepthStencilState): HResult; stdcall;

    function CreateRasterizerState(
            (* __in *)
            const pRasterizerDesc: TD3D10_RasterizerDesc;
            (* __out_opt *)
            ppRasterizerState: PID3D10RasterizerState): HResult; stdcall;

    function CreateSamplerState(
            (* __in *)
            const pSamplerDesc: TD3D10_SamplerDesc;
            (* __out_opt *)
            ppSamplerState: PID3D10SamplerState): HResult; stdcall;

    function CreateQuery(
            (* __in *)
            const pQueryDesc: TD3D10_QueryDesc;
            (* __out_opt *)
            ppQuery: PID3D10Query): HResult; stdcall;

    function CreatePredicate(
            (* __in *)
            const pPredicateDesc: TD3D10_QueryDesc;
            (* __out_opt *)
            ppPredicate: PID3D10Predicate): HResult; stdcall;

    function CreateCounter(
            (* __in *)
            const pCounterDesc: TD3D10_CounterDesc;
            (* __out_opt *)
            ppCounter: PID3D10Counter): HResult; stdcall;

    function CheckFormatSupport(
            (* __in *)
            Format: DXGI_FORMAT;
            (* __out *)
            out pFormatSupport: UINT): HResult; stdcall;

    function CheckMultisampleQualityLevels(
            (* __in *)
            Format: DXGI_FORMAT;
            (* __in *)
            SampleCount: UINT;
            (* __out *)
            out pNumQualityLevels: UINT): HResult; stdcall;

    procedure CheckCounterInfo(
            (* __out *)
            out pCounterInfo: TD3D10_CounterInfo); stdcall;


    function CheckCounter(
            (* __in  *)
            const pDesc: TD3D10_CounterDesc;
            (* __out *)
            out pType: TD3D10_CounterType;
            (* __out *)
            out pActiveCounters: UINT;
            (* __out_ecount_opt(*pNameLength) *)
            szName: LPCSTR;
            (* __inout_opt *)
            pNameLength: PLongWord;
            (* __out_ecount_opt(*pUnitsLength) *)
            szUnits: LPCSTR;
            (* __inout_opt *)
            pUnitsLength: PLongWord;
            (* __out_ecount_opt(*pDescriptionLength) *)
            szDescription: LPCSTR;
            (* __inout_opt *)
            pDescriptionLength: PLongWord): HResult; stdcall;

    function GetCreationFlags(): UINT; stdcall;

    function OpenSharedResource(
            (* __in *)
            hResource: THandle;
            (* __in *)
            const ReturnedInterface: TGUID;
            (* __out_opt *)
            ppResource: PPointer): HResult; stdcall;

    procedure SetTextFilterSize(
            (* __in *)
            Width: UINT;
            (* __in *)
            Height: UINT); stdcall;

    procedure GetTextFilterSize(
            (* __out_opt *)
            pWidth: PLongWord;
            (* __out_opt *)
            pHeight: PLongWord); stdcall;
  end;

  IID_ID3D10Device = ID3D10Device;



  ID3D10Multithread = interface (IUnknown)
    ['{9B7E4E00-342C-4106-A19F-4F2704F689F0}']
    procedure Enter(); stdcall;

    procedure Leave(); stdcall;

    function SetMultithreadProtected(
            (* __in *)
            bMTProtect: BOOL): BOOL; stdcall;

    function GetMultithreadProtected(): BOOL; stdcall;
  end;

  IID_ID3D10Multithread = ID3D10Multithread;


  PD3D10_CreateDeviceFlag = ^TD3D10_CreateDeviceFlag;
  D3D10_CREATE_DEVICE_FLAG = UINT;
  TD3D10_CreateDeviceFlag = D3D10_CREATE_DEVICE_FLAG;

const
  D3D10_CREATE_DEVICE_SINGLETHREADED = TD3D10_CreateDeviceFlag($1);
  D3D10_CREATE_DEVICE_DEBUG	         = TD3D10_CreateDeviceFlag($2);
  D3D10_CREATE_DEVICE_SWITCH_TO_REF	 = TD3D10_CreateDeviceFlag($4);
  D3D10_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS	= TD3D10_CreateDeviceFlag($8);
	D3D10_CREATE_DEVICE_ALLOW_NULL_FROM_MAP	= TD3D10_CreateDeviceFlag($10);
	D3D10_CREATE_DEVICE_BGRA_SUPPORT	= TD3D10_CreateDeviceFlag($20);


const
  D3D10_SDK_VERSION = 29;


function D3D10CalcSubresource( MipSlice, ArraySlice, MipLevels: UINT): UINT; inline;

function ColorArray(a, b, c, d: Single): TColorArray; inline;





//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10Misc.h
//  Content:    D3D10 Device Creation APIs
//
//////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////
// ID3D10Blob:
// ------------
// The buffer object is used by D3D10 to return arbitrary size data.
//
// GetBufferPointer -
//    Returns a pointer to the beginning of the buffer.
//
// GetBufferSize -
//    Returns the size of the buffer, in bytes.
///////////////////////////////////////////////////////////////////////////

type
  PID3D10Blob = ^ID3D10Blob;
  ID3D10Blob = interface (IUnknown)
    ['{8BA5FB08-5195-40e2-AC58-0D989C3A0102}']
    // ID3D10Blob
    function GetBufferPointer: Pointer; stdcall;
    function GetBufferSize: SIZE_T; stdcall;
  end;

  IID_ID3D10Blob = ID3D10Blob;


///////////////////////////////////////////////////////////////////////////
// D3D10_DRIVER_TYPE
// ----------------
//
// This identifier is used to determine the implementation of Direct3D10
// to be used.
//
// Pass one of these values to D3D10CreateDevice
//
///////////////////////////////////////////////////////////////////////////
  PD3D10DriverType = ^TD3D10DriverType;
  D3D10_DRIVER_TYPE = (
    D3D10_DRIVER_TYPE_HARDWARE  = 0,
    D3D10_DRIVER_TYPE_REFERENCE = 1,
    D3D10_DRIVER_TYPE_NULL      = 2,
    D3D10_DRIVER_TYPE_SOFTWARE  = 3,
    D3D10_DRIVER_TYPE_WARP      = 5
  );
  TD3D10DriverType = D3D10_DRIVER_TYPE;

const
  GUID_DeviceType: TGUID = '{d722fb4d-7a68-437a-b20c-5804ee2494a6}';


///////////////////////////////////////////////////////////////////////////
// D3D10CreateDevice
// ------------------
//
// pAdapter
//      If NULL, D3D10CreateDevice will choose the primary adapter and
//      create a new instance from a temporarily created IDXGIFactory.
//      If non-NULL, D3D10CreateDevice will register the appropriate
//      device, if necessary (via IDXGIAdapter::RegisterDrver), before
//      creating the device.
// DriverType
//      Specifies the driver type to be created: hardware, reference or
//      null.
// Software
//      HMODULE of a DLL implementing a software rasterizer. Must be NULL for
//      non-Software driver types.
// Flags
//      Any of those documented for D3D10CreateDevice.
// SDKVersion
//      SDK version. Use the D3D10_SDK_VERSION macro.
// ppDevice
//      Pointer to returned interface.
//
// Return Values
//  Any of those documented for
//          CreateDXGIFactory
//          IDXGIFactory::EnumAdapters
//          IDXGIAdapter::RegisterDriver
//          D3D10CreateDevice
//
///////////////////////////////////////////////////////////////////////////
function D3D10CreateDevice(
    pAdapter: IDXGIAdapter;
    DriverType: D3D10_DRIVER_TYPE;
    Software: HMODULE;
    Flags: UINT;
    SDKVersion: UINT;
    out ppDevice: ID3D10Device): HResult; stdcall; external D3D10dll;


///////////////////////////////////////////////////////////////////////////
// D3D10CreateDeviceAndSwapChain
// ------------------------------
//
// ppAdapter
//      If NULL, D3D10CreateDevice will choose the primary adapter and
//      create a new instance from a temporarily created IDXGIFactory.
//      If non-NULL, D3D10CreateDevice will register the appropriate
//      device, if necessary (via IDXGIAdapter::RegisterDrver), before
//      creating the device.
// DriverType
//      Specifies the driver type to be created: hardware, reference or
//      null.
// Software
//      HMODULE of a DLL implementing a software rasterizer. Must be NULL for
//      non-Software driver types.
// Flags
//      Any of those documented for D3D10CreateDevice.
// SDKVersion
//      SDK version. Use the D3D10_SDK_VERSION macro.
// pSwapChainDesc
//      Swap chain description, may be NULL.
// ppSwapChain
//      Pointer to returned interface. May be NULL.
// ppDevice
//      Pointer to returned interface.
//
// Return Values
//  Any of those documented for
//          CreateDXGIFactory
//          IDXGIFactory::EnumAdapters
//          IDXGIAdapter::RegisterDriver
//          D3D10CreateDevice
//          IDXGIFactory::CreateSwapChain
//
///////////////////////////////////////////////////////////////////////////
function D3D10CreateDeviceAndSwapChain(
    pAdapter: IDXGIAdapter;
    DriverType: D3D10_DRIVER_TYPE;
    Software: HMODULE;
    Flags: UINT;
    SDKVersion: UINT;
    const pSwapChainDesc: DXGI_SWAP_CHAIN_DESC;
    out ppSwapChain: IDXGISwapChain;
    out ppDevice: ID3D10Device): HResult; overload; stdcall; external D3D10dll;

function D3D10CreateDeviceAndSwapChain(
    pAdapter: IDXGIAdapter;
    DriverType: D3D10_DRIVER_TYPE;
    Software: HMODULE;
    Flags: UINT;
    SDKVersion: UINT;
    pSwapChainDesc: PDXGISwapChainDesc;
    out ppSwapChain: IDXGISwapChain;
    out ppDevice: ID3D10Device): HResult; overload; stdcall; external D3D10dll;


///////////////////////////////////////////////////////////////////////////
// D3D10CreateBlob:
// -----------------
// Creates a Buffer of n Bytes
//////////////////////////////////////////////////////////////////////////

function D3D10CreateBlob(NumBytes: SIZE_T; out ppBuffer: ID3D10Blob): HResult; stdcall; external D3D10dll;




//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10Shader.h
//  Content:    D3D10 Shader Types and APIs
//
//////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------
// D3D10_TX_VERSION:
// --------------
// Version token used to create a procedural texture filler in effects
// Used by D3D10Fill[]TX functions
//---------------------------------------------------------------------------
//#define D3D10_TX_VERSION(_Major,_Minor) (('T' << 24) | ('X' << 16) | ((_Major) << 8) | (_Minor))
function D3D10_TX_VERSION(_Major, _Minor: Byte): DWORD; inline;


//----------------------------------------------------------------------------
// D3D10SHADER flags:
// -----------------
// D3D10_SHADER_DEBUG
//   Insert debug file/line/type/symbol information.
//
// D3D10_SHADER_SKIP_VALIDATION
//   Do not validate the generated code against known capabilities and
//   constraints.  This option is only recommended when compiling shaders
//   you KNOW will work.  (ie. have compiled before without this option.)
//   Shaders are always validated by D3D before they are set to the device.
//
// D3D10_SHADER_SKIP_OPTIMIZATION
//   Instructs the compiler to skip optimization steps during code generation.
//   Unless you are trying to isolate a problem in your code using this option
//   is not recommended.
//
// D3D10_SHADER_PACK_MATRIX_ROW_MAJOR
//   Unless explicitly specified, matrices will be packed in row-major order
//   on input and output from the shader.
//
// D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR
//   Unless explicitly specified, matrices will be packed in column-major
//   order on input and output from the shader.  This is generally more
//   efficient, since it allows vector-matrix multiplication to be performed
//   using a series of dot-products.
//
// D3D10_SHADER_PARTIAL_PRECISION
//   Force all computations in resulting shader to occur at partial precision.
//   This may result in faster evaluation of shaders on some hardware.
//
// D3D10_SHADER_FORCE_VS_SOFTWARE_NO_OPT
//   Force compiler to compile against the next highest available software
//   target for vertex shaders.  This flag also turns optimizations off,
//   and debugging on.
//
// D3D10_SHADER_FORCE_PS_SOFTWARE_NO_OPT
//   Force compiler to compile against the next highest available software
//   target for pixel shaders.  This flag also turns optimizations off,
//   and debugging on.
//
// D3D10_SHADER_NO_PRESHADER
//   Disables Preshaders. Using this flag will cause the compiler to not
//   pull out static expression for evaluation on the host cpu
//
// D3D10_SHADER_AVOID_FLOW_CONTROL
//   Hint compiler to avoid flow-control constructs where possible.
//
// D3D10_SHADER_PREFER_FLOW_CONTROL
//   Hint compiler to prefer flow-control constructs where possible.
//
// D3D10_SHADER_ENABLE_STRICTNESS
//   By default, the HLSL/Effect compilers are not strict on deprecated syntax.
//   Specifying this flag enables the strict mode. Deprecated syntax may be
//   removed in a future release, and enabling syntax is a good way to make sure
//   your shaders comply to the latest spec.
//
// D3D10_SHADER_ENABLE_BACKWARDS_COMPATIBILITY
//   This enables older shaders to compile to 4_0 targets.
//
//----------------------------------------------------------------------------

const
  D3D10_SHADER_DEBUG                          = (1 shl 0);
  D3D10_SHADER_SKIP_VALIDATION                = (1 shl 1);
  D3D10_SHADER_SKIP_OPTIMIZATION              = (1 shl 2);
  D3D10_SHADER_PACK_MATRIX_ROW_MAJOR          = (1 shl 3);
  D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR       = (1 shl 4);
  D3D10_SHADER_PARTIAL_PRECISION              = (1 shl 5);
  D3D10_SHADER_FORCE_VS_SOFTWARE_NO_OPT       = (1 shl 6);
  D3D10_SHADER_FORCE_PS_SOFTWARE_NO_OPT       = (1 shl 7);
  D3D10_SHADER_NO_PRESHADER                   = (1 shl 8);
  D3D10_SHADER_AVOID_FLOW_CONTROL             = (1 shl 9);
  D3D10_SHADER_PREFER_FLOW_CONTROL            = (1 shl 10);
  D3D10_SHADER_ENABLE_STRICTNESS              = (1 shl 11);
  D3D10_SHADER_ENABLE_BACKWARDS_COMPATIBILITY = (1 shl 12);
  D3D10_SHADER_IEEE_STRICTNESS                = (1 shl 13);


  // optimization level flags
  D3D10_SHADER_OPTIMIZATION_LEVEL0            = (1 shl 14);
  D3D10_SHADER_OPTIMIZATION_LEVEL1            = 0;
  D3D10_SHADER_OPTIMIZATION_LEVEL2            = ((1 shl 14) or (1 shl 15));
  D3D10_SHADER_OPTIMIZATION_LEVEL3            = (1 shl 15);




//----------------------------------------------------------------------------
// D3D10_SHADER_MACRO:
// ----------
// Preprocessor macro definition.  The application pass in a NULL-terminated
// array of this structure to various D3D10 APIs.  This enables the application
// to #define tokens at runtime, before the file is parsed.
//----------------------------------------------------------------------------

type
  PD3D10_ShaderMacro = ^TD3D10_ShaderMacro;
  _D3D10_SHADER_MACRO = record
    Name: LPCSTR;
    Definition: LPCSTR;
  end;
  D3D10_SHADER_MACRO = _D3D10_SHADER_MACRO;
  TD3D10_ShaderMacro = _D3D10_SHADER_MACRO;


//----------------------------------------------------------------------------
// D3D10_SHADER_VARIABLE_CLASS:
//----------------------------------------------------------------------------

  PD3D10_ShaderVariableClass = ^TD3D10_ShaderVariableClass;
  _D3D10_SHADER_VARIABLE_CLASS = (
    D3D10_SVC_SCALAR,
    D3D10_SVC_VECTOR,
    D3D10_SVC_MATRIX_ROWS,
    D3D10_SVC_MATRIX_COLUMNS,
    D3D10_SVC_OBJECT,
    D3D10_SVC_STRUCT,

    D3D11_SVC_INTERFACE_CLASS,
    D3D11_SVC_INTERFACE_POINTER

    // force 32-bit size enum
    //D3D10_SVC_FORCE_DWORD = $7fffffff
  );
  D3D10_SHADER_VARIABLE_CLASS = _D3D10_SHADER_VARIABLE_CLASS;
  TD3D10_ShaderVariableClass = _D3D10_SHADER_VARIABLE_CLASS;


  PD3D10_ShaderVariableFlags = ^TD3D10_ShaderVariableFlags;
  _D3D10_SHADER_VARIABLE_FLAGS = (
    D3D10_SVF_USERPACKED = 1,
    D3D10_SVF_USED       = 2,

    D3D11_SVF_INTERFACE_POINTER = 4,

    // force 32-bit size enum
    D3D10_SVF_FORCE_DWORD = $7fffffff
  );
  D3D10_SHADER_VARIABLE_FLAGS = _D3D10_SHADER_VARIABLE_FLAGS;
  TD3D10_ShaderVariableFlags = _D3D10_SHADER_VARIABLE_FLAGS;


//----------------------------------------------------------------------------
// D3D10_SHADER_VARIABLE_TYPE:
//----------------------------------------------------------------------------

  PD3D10_ShaderVariableType = ^TD3D10_ShaderVariableType;
  _D3D10_SHADER_VARIABLE_TYPE = (
    D3D10_SVT_VOID = 0,
    D3D10_SVT_BOOL = 1,
    D3D10_SVT_INT = 2,
    D3D10_SVT_FLOAT = 3,
    D3D10_SVT_STRING = 4,
    D3D10_SVT_TEXTURE = 5,
    D3D10_SVT_TEXTURE1D = 6,
    D3D10_SVT_TEXTURE2D = 7,
    D3D10_SVT_TEXTURE3D = 8,
    D3D10_SVT_TEXTURECUBE = 9,
    D3D10_SVT_SAMPLER = 10,
    D3D10_SVT_PIXELSHADER = 15,
    D3D10_SVT_VERTEXSHADER = 16,
    D3D10_SVT_UINT = 19,
    D3D10_SVT_UINT8 = 20,
    D3D10_SVT_GEOMETRYSHADER = 21,
    D3D10_SVT_RASTERIZER = 22,
    D3D10_SVT_DEPTHSTENCIL = 23,
    D3D10_SVT_BLEND = 24,
    D3D10_SVT_BUFFER = 25,
    D3D10_SVT_CBUFFER = 26,
    D3D10_SVT_TBUFFER = 27,
    D3D10_SVT_TEXTURE1DARRAY = 28,
    D3D10_SVT_TEXTURE2DARRAY = 29,
    D3D10_SVT_RENDERTARGETVIEW = 30,
    D3D10_SVT_DEPTHSTENCILVIEW = 31,

    D3D10_SVT_TEXTURE2DMS = 32,
    D3D10_SVT_TEXTURE2DMSARRAY = 33,

    D3D10_SVT_TEXTURECUBEARRAY = 34,

    D3D11_SVT_HULLSHADER = 35,
    D3D11_SVT_DOMAINSHADER = 36,

    D3D11_SVT_INTERFACE_POINTER = 37,
    D3D11_SVT_COMPUTESHADER = 38,

    D3D11_SVT_DOUBLE = 39

    // force 32-bit size enum
    //D3D10_SVT_FORCE_DWORD = $7fffffff
  );
  D3D10_SHADER_VARIABLE_TYPE = _D3D10_SHADER_VARIABLE_TYPE;
  TD3D10_ShaderVariableType = _D3D10_SHADER_VARIABLE_TYPE;


  PD3D10_ShaderInputFlags = ^TD3D10_ShaderInputFlags;
  _D3D10_SHADER_INPUT_FLAGS = (
    D3D10_SIF_USERPACKED = 1,
    D3D10_SIF_COMPARISON_SAMPLER = 2,  // is this a comparison sampler?
    D3D10_SIF_TEXTURE_COMPONENT_0 = 4, // this 2-bit value encodes c - 1, where c
    D3D10_SIF_TEXTURE_COMPONENT_1 = 8, // is the number of components in the texture
    D3D10_SIF_TEXTURE_COMPONENTS = 12,

    // force 32-bit size enum
    D3D10_SIF_FORCE_DWORD = $7fffffff
  );
  D3D10_SHADER_INPUT_FLAGS = _D3D10_SHADER_INPUT_FLAGS;
  TD3D10_ShaderInputFlags = _D3D10_SHADER_INPUT_FLAGS;


//----------------------------------------------------------------------------
// D3D10_SHADER_INPUT_TYPE
//----------------------------------------------------------------------------

type
  PD3D10_ShaderInputType = ^TD3D10_ShaderInputType;
  _D3D10_SHADER_INPUT_TYPE = (
    D3D10_SIT_CBUFFER,
    D3D10_SIT_TBUFFER,
    D3D10_SIT_TEXTURE,
    D3D10_SIT_SAMPLER,
    D3D11_SIT_UAV_RWTYPED,
    D3D11_SIT_STRUCTURED,
    D3D11_SIT_UAV_RWSTRUCTURED,
    D3D11_SIT_BYTEADDRESS,
    D3D11_SIT_UAV_RWBYTEADDRESS,
    D3D11_SIT_UAV_APPEND_BYTEADDRESS,
    D3D11_SIT_UAV_CONSUME_BYTEADDRESS,
    D3D11_SIT_UAV_APPEND_STRUCTURED,
    D3D11_SIT_UAV_CONSUME_STRUCTURED
  );
  D3D10_SHADER_INPUT_TYPE = _D3D10_SHADER_INPUT_TYPE;
  TD3D10_ShaderInputType = _D3D10_SHADER_INPUT_TYPE;


  PD3D10_ShaderCBufferFlags = ^TD3D10_ShaderCBufferFlags;
  _D3D10_SHADER_CBUFFER_FLAGS = (
    D3D10_CBF_USERPACKED = 1,

    // force 32-bit size enum
    D3D10_CBF_FORCE_DWORD = $7fffffff
  );
  D3D10_SHADER_CBUFFER_FLAGS = _D3D10_SHADER_CBUFFER_FLAGS;
  TD3D10_ShaderCBufferFlags = _D3D10_SHADER_CBUFFER_FLAGS;


  PD3D10_CBufferType = ^TD3D10_CBufferType;
  _D3D10_CBUFFER_TYPE = (
    D3D10_CT_CBUFFER,
    D3D10_CT_TBUFFER
  );
  D3D10_CBUFFER_TYPE = _D3D10_CBUFFER_TYPE;
  TD3D10_CBufferType = _D3D10_CBUFFER_TYPE;


  PD3D10_Name = ^TD3D10_Name;
  D3D10_NAME = (
    D3D10_NAME_UNDEFINED = 0,

    // Names meaningful to both HLSL and hardware
    D3D10_NAME_POSITION = 1,
    D3D10_NAME_CLIP_DISTANCE = 2,
    D3D10_NAME_CULL_DISTANCE = 3,
    D3D10_NAME_RENDER_TARGET_ARRAY_INDEX = 4,
    D3D10_NAME_VIEWPORT_ARRAY_INDEX = 5,
    D3D10_NAME_VERTEX_ID = 6,
    D3D10_NAME_PRIMITIVE_ID = 7,
    D3D10_NAME_INSTANCE_ID = 8,
    D3D10_NAME_IS_FRONT_FACE = 9,
    D3D10_NAME_SAMPLE_INDEX = 10,
    D3D11_NAME_FINAL_QUAD_EDGE_TESSFACTOR = 11,
    D3D11_NAME_FINAL_QUAD_INSIDE_TESSFACTOR = 12,
    D3D11_NAME_FINAL_TRI_EDGE_TESSFACTOR = 13,
    D3D11_NAME_FINAL_TRI_INSIDE_TESSFACTOR = 14,
    D3D11_NAME_FINAL_LINE_DETAIL_TESSFACTOR = 15,
    D3D11_NAME_FINAL_LINE_DENSITY_TESSFACTOR = 16,

    // Names meaningful to HLSL only
    D3D10_NAME_TARGET = 64,
    D3D10_NAME_DEPTH = 65,
    D3D10_NAME_COVERAGE = 66,
    D3D11_NAME_DEPTH_GREATER_EQUAL = 67,
    D3D11_NAME_DEPTH_LESS_EQUAL = 68
  );
  TD3D10_Name = D3D10_NAME;


  PD3D10_ResourceReturnType = ^TD3D10_ResourceReturnType;
  D3D10_RESOURCE_RETURN_TYPE = (
    D3D10_RETURN_TYPE_UNORM = 1,
    D3D10_RETURN_TYPE_SNORM = 2,
    D3D10_RETURN_TYPE_SINT = 3,
    D3D10_RETURN_TYPE_UINT = 4,
    D3D10_RETURN_TYPE_FLOAT = 5,
    D3D10_RETURN_TYPE_MIXED = 6
  );
  TD3D10_ResourceReturnType = D3D10_RESOURCE_RETURN_TYPE;


  PD3D10_RegisterComponentType = ^TD3D10_RegisterComponentType;
  D3D10_REGISTER_COMPONENT_TYPE = (
    D3D10_REGISTER_COMPONENT_UNKNOWN = 0,
    D3D10_REGISTER_COMPONENT_UINT32 = 1,
    D3D10_REGISTER_COMPONENT_SINT32 = 2,
    D3D10_REGISTER_COMPONENT_FLOAT32 = 3
  );
  TD3D10_RegisterComponentType = D3D10_REGISTER_COMPONENT_TYPE;


//----------------------------------------------------------------------------
// D3D10_INCLUDE_TYPE:
//----------------------------------------------------------------------------

  PD3D10IncludeType = ^TD3D10IncludeType;
  _D3D10_INCLUDE_TYPE = (
    D3D10_INCLUDE_LOCAL,
    D3D10_INCLUDE_SYSTEM
  );
  D3D10_INCLUDE_TYPE = _D3D10_INCLUDE_TYPE;
  TD3D10IncludeType = _D3D10_INCLUDE_TYPE;


//----------------------------------------------------------------------------
// ID3D10Include:
// -------------
// This interface is intended to be implemented by the application, and can
// be used by various D3D10 APIs.  This enables application-specific handling
// of #include directives in source files.
//
// Open()
//    Opens an include file.  If successful, it should fill in ppData and
//    pBytes.  The data pointer returned must remain valid until Close is
//    subsequently called.  The name of the file is encoded in UTF-8 format.
// Close()
//    Closes an include file.  If Open was successful, Close is guaranteed
//    to be called before the API using this interface returns.
//----------------------------------------------------------------------------

  ID3D10Include = class
    function Open(IncludeType: TD3D10IncludeType; pFileName: LPCSTR; pParentData: Pointer; out ppData: LPVOID; out pBytes: UINT): HResult; virtual; stdcall; abstract;
    function Close(pData: LPVOID): HResult; virtual; stdcall; abstract;
  end;

//----------------------------------------------------------------------------
// ID3D10ShaderReflection:
//----------------------------------------------------------------------------

//
// Structure definitions
//

  PD3D10_ShaderDesc = ^TD3D10_ShaderDesc;
  _D3D10_SHADER_DESC = record
    Version:                     UINT;   // Shader version
    Creator:                     LPCSTR;  // Creator string
    Flags:                       UINT;   // Shader compilation/parse flags

    ConstantBuffers:             UINT;   // Number of constant buffers
    BoundResources:              UINT;   // Number of bound resources
    InputParameters:             UINT;   // Number of parameters in the input signature
    OutputParameters:            UINT;   // Number of parameters in the output signature

    InstructionCount:            UINT;   // Number of emitted instructions
    TempRegisterCount:           UINT;   // Number of temporary registers used
    TempArrayCount:              UINT;   // Number of temporary arrays used
    DefCount:                    UINT;   // Number of constant defines
    DclCount:                    UINT;   // Number of declarations (input + output)
    TextureNormalInstructions:   UINT;   // Number of non-categorized texture instructions
    TextureLoadInstructions:     UINT;   // Number of texture load instructions
    TextureCompInstructions:     UINT;   // Number of texture comparison instructions
    TextureBiasInstructions:     UINT;   // Number of texture bias instructions
    TextureGradientInstructions: UINT;   // Number of texture gradient instructions
    FloatInstructionCount:       UINT;   // Number of floating point arithmetic instructions used
    IntInstructionCount:         UINT;   // Number of signed integer arithmetic instructions used
    UintInstructionCount:        UINT;   // Number of unsigned integer arithmetic instructions used
    StaticFlowControlCount:      UINT;   // Number of static flow control instructions used
    DynamicFlowControlCount:     UINT;   // Number of dynamic flow control instructions used
    MacroInstructionCount:       UINT;   // Number of macro instructions used
    ArrayInstructionCount:       UINT;   // Number of array instructions used
    CutInstructionCount:         UINT;   // Number of cut instructions used
    EmitInstructionCount:        UINT;   // Number of emit instructions used
    GSOutputTopology:            TD3D10_PrimitiveTopology; // Geometry shader output topology
    GSMaxOutputVertexCount:      UINT;   // Geometry shader maximum output vertex count
  end;
  D3D10_SHADER_DESC = _D3D10_SHADER_DESC;
  TD3D10_ShaderDesc = _D3D10_SHADER_DESC;


  PD3D10_ShaderBufferDesc = ^TD3D10_ShaderBufferDesc;
  _D3D10_SHADER_BUFFER_DESC = record
    Name: LPCSTR;               // Name of the constant buffer
    Type_: TD3D10_CBufferType;     // Indicates that this is a CBuffer or TBuffer
    Variables: UINT;           // Number of member variables
    Size: UINT;                // Size of CB (in bytes)
    uFlags: UINT;              // Buffer description flags
  end;
  D3D10_SHADER_BUFFER_DESC = _D3D10_SHADER_BUFFER_DESC;
  TD3D10_ShaderBufferDesc = _D3D10_SHADER_BUFFER_DESC;


  PD3D10_ShaderVariableDesc = ^TD3D10_ShaderVariableDesc;
  _D3D10_SHADER_VARIABLE_DESC = record
    Name: LPCSTR;               // Name of the variable
    StartOffset: UINT;         // Offset in constant buffer's backing store
    Size: UINT;                // Size of variable (in bytes)
    DefaultValue: Pointer;         // Raw pointer to default value
    uFlags: UINT;              // Variable flags
  end;
  D3D10_SHADER_VARIABLE_DESC = _D3D10_SHADER_VARIABLE_DESC;
  TD3D10_ShaderVariableDesc = _D3D10_SHADER_VARIABLE_DESC;


  PD3D10_ShaderTypeDesc = ^TD3D10_ShaderTypeDesc;
  _D3D10_SHADER_TYPE_DESC = record
    Class_: TD3D10_ShaderVariableClass; // Variable class (e.g. object, matrix, etc.)
    Type_: TD3D10_ShaderVariableType;   // Variable type (e.g. float, sampler, etc.)
    Rows: UINT;                // Number of rows (for matrices, 1 for other numeric, 0 if not applicable)
    Columns: UINT;             // Number of columns (for vectors & matrices, 1 for other numeric, 0 if not applicable)
    Elements: UINT;            // Number of elements (0 if not an array)
    Members: UINT;             // Number of members (0 if not a structure)
    Offset: UINT;              // Offset from the start of structure (0 if not a structure member)
  end;
  D3D10_SHADER_TYPE_DESC = _D3D10_SHADER_TYPE_DESC;
  TD3D10_ShaderTypeDesc = _D3D10_SHADER_TYPE_DESC;


  PD3D10_ShaderInputBindDesc = ^TD3D10_ShaderInputBindDesc;
  _D3D10_SHADER_INPUT_BIND_DESC = record
    Name: LPCSTR;               // Name of the resource
    Type_: TD3D10_ShaderInputType; // Type of resource (e.g. texture, cbuffer, etc.)
    BindPoint: UINT;           // Starting bind point
    BindCount: UINT;           // Number of contiguous bind points (for arrays)

    uFlags: UINT;              // Input binding flags
    ReturnType: TD3D10_ResourceReturnType; // Return type (if texture)
    Dimension: TD3D10_SRV_Dimension; // Dimension (if texture)
    NumSamples: UINT;          // Number of samples (0 if not MS texture)
  end;
  D3D10_SHADER_INPUT_BIND_DESC = _D3D10_SHADER_INPUT_BIND_DESC;
  TD3D10_ShaderInputBindDesc = _D3D10_SHADER_INPUT_BIND_DESC;


  PD3D10_SignatureParameterDesc = ^TD3D10_SignatureParameterDesc;
  _D3D10_SIGNATURE_PARAMETER_DESC = record
    SemanticName: LPCSTR;       // Name of the semantic
    SemanticIndex: UINT;       // Index of the semantic
    Register: UINT;            // Number of member variables
    SystemValueType: TD3D10_Name;  // A predefined system value, or D3D10_NAME_UNDEFINED if not applicable
    ComponentType: TD3D10_RegisterComponentType; // Scalar type (e.g. uint, float, etc.)
    Mask: Byte;                    // Mask to indicate which components of the register
                                   // are used (combination of D3D10_COMPONENT_MASK values)
    ReadWriteMask: Byte;           // Mask to indicate whether a given component is
                                   // never written (if this is an output signature) or
                                   // always read (if this is an input signature).
                                   // (combination of D3D10_COMPONENT_MASK values)
  end;
  D3D10_SIGNATURE_PARAMETER_DESC = _D3D10_SIGNATURE_PARAMETER_DESC;
  TD3D10_SignatureParameterDesc = _D3D10_SIGNATURE_PARAMETER_DESC;


//
// Interface definitions
//

  ID3D10ShaderReflectionType = class
    function GetDesc(out pDesc: TD3D10_ShaderTypeDesc): HResult; virtual; stdcall; abstract;

    function GetMemberTypeByIndex(Index: UINT): ID3D10ShaderReflectionType; virtual; stdcall; abstract;
    function GetMemberTypeByName(Name: LPCSTR): ID3D10ShaderReflectionType; virtual; stdcall; abstract;
    function GetMemberTypeName(Index: UINT): LPCSTR; virtual; stdcall; abstract;
  end;

  ID3D10ShaderReflectionVariable = class
    function GetDesc(out pDesc: TD3D10_ShaderVariableDesc): HResult; virtual; stdcall; abstract;

    function GetType: ID3D10ShaderReflectionType; virtual; stdcall; abstract;
  end;


  ID3D10ShaderReflectionConstantBuffer = class
    function GetDesc(out pDesc: TD3D10_ShaderBufferDesc): HResult; virtual; stdcall; abstract;

    function GetVariableByIndex(Index: UINT): ID3D10ShaderReflectionVariable; virtual; stdcall; abstract;
    function GetVariableByName(Name: LPCSTR): ID3D10ShaderReflectionVariable; virtual; stdcall; abstract;
  end;

const
  // {C530AD7D-9B16-4395-A979-BA2ECFF83ADD}
  IID_ID3D10ShaderReflectionType: TGUID = '{c530ad7d-9b16-4395-a979-ba2ecff83add}';
  // {1BF63C95-2650-405d-99C1-3636BD1DA0A1}
  IID_ID3D10ShaderReflectionVariable: TGUID = '{1bf63c95-2650-405d-99c1-3636bd1da0a1}';
  // {66C66A94-DDDD-4b62-A66A-F0DA33C2B4D0}
  IID_ID3D10ShaderReflectionConstantBuffer: TGUID = '{66c66a94-dddd-4b62-a66a-f0da33c2b4d0}';


type
  ID3D10ShaderReflection = interface (IUnknown)
    ['{D40E20B6-F8F7-42ad-AB20-4BAF8F15DFAA}']
    function GetDesc(out pDesc: TD3D10_ShaderDesc): HResult; stdcall;

    function GetConstantBufferByIndex(Index: UINT): ID3D10ShaderReflectionConstantBuffer; stdcall;
    function GetConstantBufferByName(Name: LPCSTR): ID3D10ShaderReflectionConstantBuffer; stdcall;

    function GetResourceBindingDesc(ResourceIndex: UINT; out pDesc: TD3D10_ShaderInputBindDesc): HResult; stdcall;

    function GetInputParameterDesc(ParameterIndex: UINT; pDesc: TD3D10_SignatureParameterDesc): HResult; stdcall;
    function GetOutputParameterDesc(ParameterIndex: UINT; pDesc: TD3D10_SignatureParameterDesc): HResult; stdcall;
  end;

  IID_ID3D10ShaderReflection = ID3D10ShaderReflection;


//////////////////////////////////////////////////////////////////////////////
// APIs //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////



//----------------------------------------------------------------------------
// D3D10CompileShader:
// ------------------
// Compiles a shader.
//
// Parameters:
//  pSrcFile
//      Source file name.
//  hSrcModule
//      Module handle. if NULL, current module will be used.
//  pSrcResource
//      Resource name in module.
//  pSrcData
//      Pointer to source code.
//  SrcDataLen
//      Size of source code, in bytes.
//  pDefines
//      Optional NULL-terminated array of preprocessor macro definitions.
//  pInclude
//      Optional interface pointer to use for handling #include directives.
//      If this parameter is NULL, #includes will be honored when compiling
//      from file, and will error when compiling from resource or memory.
//  pFunctionName
//      Name of the entrypoint function where execution should begin.
//  pProfile
//      Instruction set to be used when generating code.  The D3D10 entry
//      point currently supports only "vs_4_0", "ps_4_0", and "gs_4_0".
//  Flags
//      See D3D10_SHADER_xxx flags.
//  ppShader
//      Returns a buffer containing the created shader.  This buffer contains
//      the compiled shader code, as well as any embedded debug and symbol
//      table info.  (See D3D10GetShaderConstantTable)
//  ppErrorMsgs
//      Returns a buffer containing a listing of errors and warnings that were
//      encountered during the compile.  If you are running in a debugger,
//      these are the same messages you will see in your debug output.
//----------------------------------------------------------------------------

function D3D10CompileShader(pSrcData: LPCSTR; SrcDataLen: SIZE_T;
    pFileName: LPCSTR; const pDefines: PD3D10_ShaderMacro; pInclude: ID3D10Include;
    pFunctionName: LPCSTR; pProfile: LPCSTR; Flags: UINT;
    out ppShader: ID3D10Blob; ppErrorMsgs: PID3D10Blob): HRESULT; stdcall; external D3D10dll;

//----------------------------------------------------------------------------
// D3D10DisassembleShader:
// ----------------------
// Takes a binary shader, and returns a buffer containing text assembly.
//
// Parameters:
//  pShader
//      Pointer to the shader byte code.
//  BytecodeLength
//      Size of the shader byte code in bytes.
//  EnableColorCode
//      Emit HTML tags for color coding the output?
//  pComments
//      Pointer to a comment string to include at the top of the shader.
//  ppDisassembly
//      Returns a buffer containing the disassembled shader.
//----------------------------------------------------------------------------

function D3D10DisassembleShader(const pShader: Pointer; BytecodeLength: SIZE_T;
  EnableColorCode: BOOL; pComments: LPCSTR; out ppDisassembly: ID3D10Blob): HRESULT; stdcall; external D3D10dll;


//----------------------------------------------------------------------------
// D3D10GetPixelShaderProfile/D3D10GetVertexShaderProfile/D3D10GetGeometryShaderProfile:
// -----------------------------------------------------
// Returns the name of the HLSL profile best suited to a given device.
//
// Parameters:
//  pDevice
//      Pointer to the device in question
//----------------------------------------------------------------------------

function D3D10GetPixelShaderProfile(const pDevice: ID3D10Device): LPCSTR; stdcall; external d3d10dll;

function D3D10GetVertexShaderProfile(const pDevice: ID3D10Device): LPCSTR; stdcall; external d3d10dll;

function D3D10GetGeometryShaderProfile(const pDevice: ID3D10Device): LPCSTR; stdcall; external d3d10dll;


//----------------------------------------------------------------------------
// D3D10ReflectShader:
// ------------------
// Creates a shader reflection object that can be used to retrieve information
// about a compiled shader
//
// Parameters:
//  pShaderBytecode
//      Pointer to a compiled shader (same pointer that is passed into
//      ID3D10Device::CreateShader)
//  BytecodeLength
//      Length of the shader bytecode buffer
//  ppReflector
//      [out] Returns a ID3D10ShaderReflection object that can be used to
//      retrieve shader resource and constant buffer information
//
//----------------------------------------------------------------------------

function D3D10ReflectShader(const pShaderBytecode: Pointer; BytecodeLength: SIZE_T;
    out ppReflector: ID3D10ShaderReflection): HRESULT; stdcall; external d3d10dll;

//----------------------------------------------------------------------------
// D3D10PreprocessShader
// ---------------------
// Creates a shader reflection object that can be used to retrieve information
// about a compiled shader
//
// Parameters:
//  pSrcData
//      Pointer to source code
//  SrcDataLen
//      Size of source code, in bytes
//  pFileName
//      Source file name (used for error output)
//  pDefines
//      Optional NULL-terminated array of preprocessor macro definitions.
//  pInclude
//      Optional interface pointer to use for handling #include directives.
//      If this parameter is NULL, #includes will be honored when assembling
//      from file, and will error when assembling from resource or memory.
//  ppShaderText
//      Returns a buffer containing a single large string that represents
//      the resulting formatted token stream
//  ppErrorMsgs
//      Returns a buffer containing a listing of errors and warnings that were
//      encountered during assembly.  If you are running in a debugger,
//      these are the same messages you will see in your debug output.
//----------------------------------------------------------------------------

function D3D10PreprocessShader(pSrcData: LPCSTR; SrcDataSize: SIZE_T;
    pFileName: LPCSTR; const pDefines: PD3D10_ShaderMacro; pInclude: ID3D10Include;
    out ppShaderText: ID3D10Blob; ppErrorMsgs: PID3D10Blob): HRESULT; stdcall; external d3d10dll;

//////////////////////////////////////////////////////////////////////////
//
// Shader blob manipulation routines
// ---------------------------------
//
// void *pShaderBytecode - a buffer containing the result of an HLSL
//  compilation.  Typically this opaque buffer contains several
//  discrete sections including the shader executable code, the input
//  signature, and the output signature.  This can typically be retrieved
//  by calling ID3D10Blob::GetBufferPointer() on the returned blob
//  from HLSL's compile APIs.
//
// UINT BytecodeLength - the length of pShaderBytecode.  This can
//  typically be retrieved by calling ID3D10Blob::GetBufferSize()
//  on the returned blob from HLSL's compile APIs.
//
// ID3D10Blob **ppSignatureBlob(s) - a newly created buffer that
//  contains only the signature portions of the original bytecode.
//  This is a copy; the original bytecode is not modified.  You may
//  specify NULL for this parameter to have the bytecode validated
//  for the presence of the corresponding signatures without actually
//  copying them and creating a new blob.
//
// Returns E_INVALIDARG if any required parameters are NULL
// Returns E_FAIL is the bytecode is corrupt or missing signatures
// Returns S_OK on success
//
//////////////////////////////////////////////////////////////////////////

function D3D10GetInputSignatureBlob(const pShaderBytecode: Pointer; BytecodeLength: SIZE_T; out ppSignatureBlob: ID3D10Blob): HRESULT; stdcall; external d3d10dll;
function D3D10GetOutputSignatureBlob(const pShaderBytecode: Pointer; BytecodeLength: SIZE_T; out ppSignatureBlob: ID3D10Blob): HRESULT; stdcall; external d3d10dll;
function D3D10GetInputAndOutputSignatureBlob(const pShaderBytecode: Pointer; BytecodeLength: SIZE_T; out ppSignatureBlob: ID3D10Blob): HRESULT; stdcall; external d3d10dll;


//----------------------------------------------------------------------------
// D3D10GetShaderDebugInfo:
// -----------------------
// Gets shader debug info.  Debug info is generated by D3D10CompileShader and is
// embedded in the body of the shader.
//
// Parameters:
//  pShaderBytecode
//      Pointer to the function bytecode
//  BytecodeLength
//      Length of the shader bytecode buffer
//  ppDebugInfo
//      Buffer used to return debug info.  For information about the layout
//      of this buffer, see definition of D3D10_SHADER_DEBUG_INFO above.
//----------------------------------------------------------------------------

function D3D10GetShaderDebugInfo(const pShaderBytecode: Pointer; BytecodeLength: SIZE_T; out ppDebugInfo: ID3D10Blob): HRESULT; stdcall; external d3d10dll;





//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10Effect.h
//  Content:    D3D10 Stateblock/Effect Types & APIs
//
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// File contents:
//
// 1) Stateblock enums, structs, interfaces, flat APIs
// 2) Effect enums, structs, interfaces, flat APIs
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_DEVICE_STATE_TYPES:
//
// Used in ID3D10StateBlockMask function calls
//
//----------------------------------------------------------------------------

type
  PD3D10_DeviceStateTypes = ^TD3D10_DeviceStateTypes;
  _D3D10_DEVICE_STATE_TYPES = (
    D3D10_DST_INVALID_0,
    D3D10_DST_SO_BUFFERS{=1},           // Single-value state (atomical gets/sets)
    D3D10_DST_OM_RENDER_TARGETS,        // Single-value state (atomical gets/sets)
    D3D10_DST_OM_DEPTH_STENCIL_STATE,   // Single-value state
    D3D10_DST_OM_BLEND_STATE,           // Single-value state

    D3D10_DST_VS,                       // Single-value state
    D3D10_DST_VS_SAMPLERS,              // Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
    D3D10_DST_VS_SHADER_RESOURCES,      // Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
    D3D10_DST_VS_CONSTANT_BUFFERS,      // Count:

    D3D10_DST_GS,                       // Single-value state
    D3D10_DST_GS_SAMPLERS,              // Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
    D3D10_DST_GS_SHADER_RESOURCES,      // Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
    D3D10_DST_GS_CONSTANT_BUFFERS,      // Count: D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT

    D3D10_DST_PS,                       // Single-value state
    D3D10_DST_PS_SAMPLERS,              // Count: D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
    D3D10_DST_PS_SHADER_RESOURCES,      // Count: D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT
    D3D10_DST_PS_CONSTANT_BUFFERS,      // Count: D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT

    D3D10_DST_IA_VERTEX_BUFFERS,        // Count: D3D10_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT
    D3D10_DST_IA_INDEX_BUFFER,          // Single-value state
    D3D10_DST_IA_INPUT_LAYOUT,          // Single-value state
    D3D10_DST_IA_PRIMITIVE_TOPOLOGY,    // Single-value state

    D3D10_DST_RS_VIEWPORTS,             // Single-value state (atomical gets/sets)
    D3D10_DST_RS_SCISSOR_RECTS,         // Single-value state (atomical gets/sets)
    D3D10_DST_RS_RASTERIZER_STATE,      // Single-value state

    D3D10_DST_PREDICATION               // Single-value state
  );
  D3D10_DEVICE_STATE_TYPES = _D3D10_DEVICE_STATE_TYPES;
  TD3D10_DeviceStateTypes = _D3D10_DEVICE_STATE_TYPES;


//----------------------------------------------------------------------------
// D3D10_DEVICE_STATE_TYPES:
//
// Used in ID3D10StateBlockMask function calls
//
//----------------------------------------------------------------------------

// #define D3D10_BYTES_FROM_BITS(x) (((x) + 7) / 8)
function D3D10_BYTES_FROM_BITS(x: DWORD): DWORD; inline;

type
  PD3D10_StateBlockMask = ^TD3D10_StateBlockMask;
  _D3D10_STATE_BLOCK_MASK = record
    VS: Byte;
    VSSamplers: array[0..((D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT + 7) div 8) - 1] of Byte;
    VSShaderResources: array[0..((D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT + 7) div 8) - 1] of Byte;
    VSConstantBuffers: array[0..((D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT + 7) div 8) - 1] of Byte;

    GS: Byte;
    GSSamplers: array[0..((D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT + 7) div 8) - 1] of Byte;
    GSShaderResources: array[0..((D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT + 7) div 8) - 1] of Byte;
    GSConstantBuffers: array[0..((D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT + 7) div 8) - 1] of Byte;

    PS: Byte;
    PSSamplers: array[0..((D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT + 7) div 8) - 1] of Byte;
    PSShaderResources: array[0..((D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT + 7) div 8) - 1] of Byte;
    PSConstantBuffers: array[0..((D3D10_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT + 7) div 8) - 1] of Byte;

    IAVertexBuffers: array[0..((D3D10_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT + 7) div 8) - 1] of Byte;
    IAIndexBuffer: Byte;
    IAInputLayout: Byte;
    IAPrimitiveTopology: Byte;

    OMRenderTargets: Byte;
    OMDepthStencilState: Byte;
    OMBlendState: Byte;

    RSViewports: Byte;
    RSScissorRects: Byte;
    RSRasterizerState: Byte;

    SOBuffers: Byte;

    Predication: Byte;
  end;
  D3D10_STATE_BLOCK_MASK = _D3D10_STATE_BLOCK_MASK;
  TD3D10_StateBlockMask = _D3D10_STATE_BLOCK_MASK;


//////////////////////////////////////////////////////////////////////////////
// ID3D10StateBlock //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

  ID3D10StateBlock = interface (IUnknown)
    ['{0803425A-57F5-4dd6-9465-A87570834A08}']
    function Capture(): HResult; stdcall;
    function Apply(): HResult; stdcall;
    function ReleaseAllDeviceObjects(): HResult; stdcall;
    function GetDevice(out ppDevice: ID3D10Device): HResult; stdcall;
  end;

  IID_ID3D10StateBlock = ID3D10StateBlock;


//----------------------------------------------------------------------------
// D3D10_STATE_BLOCK_MASK and manipulation functions
// -------------------------------------------------
//
// These functions exist to facilitate working with the D3D10_STATE_BLOCK_MASK
// structure.
//
// D3D10_STATE_BLOCK_MASK *pResult or *pMask
//   The state block mask to operate on
//
// D3D10_STATE_BLOCK_MASK *pA, *pB
//   The source state block masks for the binary union/intersect/difference
//   operations.
//
// D3D10_DEVICE_STATE_TYPES StateType
//   The specific state type to enable/disable/query
//
// UINT RangeStart, RangeLength, Entry
//   The specific bit or range of bits for a given state type to operate on.
//   Consult the comments for D3D10_DEVICE_STATE_TYPES and
//   D3D10_STATE_BLOCK_MASK for information on the valid bit ranges for
//   each state.
//
//----------------------------------------------------------------------------

function D3D10StateBlockMaskUnion(const pA, pB: TD3D10_StateBlockMask; out pResult: TD3D10_StateBlockMask): HResult; external d3d10dll;
function D3D10StateBlockMaskIntersect(const pA, pB: TD3D10_StateBlockMask; out pResult: TD3D10_StateBlockMask): HResult; external d3d10dll;
function D3D10StateBlockMaskDifference(const pA, pB: TD3D10_StateBlockMask; out pResult: TD3D10_StateBlockMask): HResult; external d3d10dll;
function D3D10StateBlockMaskEnableCapture(var pMask: TD3D10_StateBlockMask; StateType: TD3D10_DeviceStateTypes; RangeStart, RangeLength: UINT): HResult; external d3d10dll;
function D3D10StateBlockMaskDisableCapture(var pMask: TD3D10_StateBlockMask; StateType: TD3D10_DeviceStateTypes; RangeStart, RangeLength: UINT): HResult; external d3d10dll;
function D3D10StateBlockMaskEnableAll(var pMask: TD3D10_StateBlockMask): HResult; external d3d10dll;
function D3D10StateBlockMaskDisableAll(var pMask: TD3D10_StateBlockMask): HResult; external d3d10dll;
function D3D10StateBlockMaskGetSetting(const pMask: TD3D10_StateBlockMask; StateType: TD3D10_DeviceStateTypes; Entry: UINT): BOOL; external d3d10dll;


//----------------------------------------------------------------------------
// D3D10CreateStateBlock
// ---------------------
//
// Creates a state block object based on the mask settings specified
//   in a D3D10_STATE_BLOCK_MASK structure.
//
// ID3D10Device *pDevice
//      The device interface to associate with this state block
//
// D3D10_STATE_BLOCK_MASK *pStateBlockMask
//      A bit mask whose settings are used to generate a state block
//      object.
//
// ID3D10StateBlock **ppStateBlock
//      The resulting state block object.  This object will save/restore
//      only those pieces of state that were set in the state block
//      bit mask
//----------------------------------------------------------------------------

function D3D10CreateStateBlock(const pDevice: ID3D10Device; const pStateBlockMask: TD3D10_StateBlockMask; out ppStateBlock: ID3D10StateBlock): HResult; external d3d10dll;


//----------------------------------------------------------------------------
// D3D10_COMPILE & D3D10_EFFECT flags:
// -------------------------------------
//
// These flags are passed in when creating an effect, and affect
// either compilation behavior or runtime effect behavior
//
// D3D10_EFFECT_COMPILE_CHILD_EFFECT
//   Compile this .fx file to a child effect. Child effects have no initializers
//   for any shared values as these are initialied in the master effect (pool).
//
// D3D10_EFFECT_COMPILE_ALLOW_SLOW_OPS
//   By default, performance mode is enabled.  Performance mode disallows
//   mutable state objects by preventing non-literal expressions from appearing in
//   state object definitions.  Specifying this flag will disable the mode and allow
//   for mutable state objects.
//
// D3D10_EFFECT_SINGLE_THREADED
//   Do not attempt to synchronize with other threads loading effects into the
//   same pool.
//
//----------------------------------------------------------------------------

const
  D3D10_EFFECT_COMPILE_CHILD_EFFECT              = (1 shl 0);
  D3D10_EFFECT_COMPILE_ALLOW_SLOW_OPS            = (1 shl 1);
  D3D10_EFFECT_SINGLE_THREADED                   = (1 shl 3);


//----------------------------------------------------------------------------
// D3D10_EFFECT_VARIABLE flags:
// ----------------------------
//
// These flags describe an effect variable (global or annotation),
// and are returned in D3D10_EFFECT_VARIABLE_DESC::Flags.
//
// D3D10_EFFECT_VARIABLE_POOLED
//   Indicates that the this variable or constant buffer resides
//   in an effect pool. If this flag is not set, then the variable resides
//   in a standalone effect (if ID3D10Effect::GetPool returns NULL)
//   or a child effect (if ID3D10Effect::GetPool returns non-NULL)
//
// D3D10_EFFECT_VARIABLE_ANNOTATION
//   Indicates that this is an annotation on a technique, pass, or global
//   variable. Otherwise, this is a global variable. Annotations cannot
//   be shared.
//
// D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT
//   Indicates that the variable has been explicitly bound using the
//   register keyword.
//----------------------------------------------------------------------------

const
  D3D10_EFFECT_VARIABLE_POOLED                  = (1 shl 0);
  D3D10_EFFECT_VARIABLE_ANNOTATION              = (1 shl 1);
  D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT     = (1 shl 2);

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectType //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_EFFECT_TYPE_DESC:
//
// Retrieved by ID3D10EffectType::GetDesc()
//----------------------------------------------------------------------------

type
  PD3D10_EffectTypeDesc = ^TD3D10_EffectTypeDesc;
  _D3D10_EFFECT_TYPE_DESC = record
    TypeName:     LPCSTR;        // Name of the type
                                    // (e.g. "float4" or "MyStruct")

    Class_: TD3D10_ShaderVariableClass;  // (e.g. scalar, vector, object, etc.)
    Type_:  TD3D10_ShaderVariableType;   // (e.g. float, texture, vertexshader, etc.)

    Elements:     UINT;         // Number of elements in this type
                                    // (0 if not an array)
    Members:      UINT;         // Number of members
                                    // (0 if not a structure)
    Rows:         UINT;         // Number of rows in this type
                                    // (0 if not a numeric primitive)
    Columns:      UINT;         // Number of columns in this type
                                    // (0 if not a numeric primitive)

    PackedSize:   UINT;         // Number of bytes required to represent
                                    // this data type, when tightly packed
    UnpackedSize: UINT;         // Number of bytes occupied by this data
                                    // type, when laid out in a constant buffer
    Stride:       UINT;         // Number of bytes to seek between elements,
                                    // when laid out in a constant buffer
  end;
  D3D10_EFFECT_TYPE_DESC = _D3D10_EFFECT_TYPE_DESC;
  TD3D10_EffectTypeDesc = _D3D10_EFFECT_TYPE_DESC;


const
  IID_ID3D10EffectType: TGUID = '{4E9E1DDC-CD9D-4772-A837-00180B9B88FD}';


type
  ID3D10EffectType = class
    function IsValid(): BOOL; virtual; stdcall; abstract;
    function GetDesc(out pDesc: TD3D10_EFFECTTYPEDESC): HResult; virtual; stdcall; abstract;
    function GetMemberTypeByIndex(Index: UINT): ID3D10EffectType; virtual; stdcall; abstract;
    function GetMemberTypeByName(Name: LPCSTR): ID3D10EffectType; virtual; stdcall; abstract;
    function GetMemberTypeBySemantic(Semantic: LPCSTR): ID3D10EffectType; virtual; stdcall; abstract;
    function GetMemberName(Index: UINT): LPCSTR; virtual; stdcall; abstract;
    function GetMemberSemantic(Index: UINT): LPCSTR; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectVariable //////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_EFFECT_VARIABLE_DESC:
//
// Retrieved by ID3D10EffectVariable::GetDesc()
//----------------------------------------------------------------------------

  PD3D10_EffectVariableDesc = ^TD3D10_EffectVariableDesc;
  _D3D10_EFFECT_VARIABLE_DESC = record
    Name: LPCSTR;                // Name of this variable, annotation,
                                    // or structure member
    Semantic:  LPCSTR;           // Semantic string of this variable
                                    // or structure member (NULL for
                                    // annotations or if not present)

    Flags: UINT;                // D3D10_EFFECT_VARIABLE_* flags
    Annotations: UINT;          // Number of annotations on this variable
                                    // (always 0 for annotations)

    BufferOffset: UINT;         // Offset into containing cbuffer or tbuffer
                                    // (always 0 for annotations or variables
                                    // not in constant buffers)

    ExplicitBindPoint: UINT;    // Used if the variable has been explicitly bound
                                    // using the register keyword. Check Flags for
                                    // D3D10_EFFECT_VARIABLE_EXPLICIT_BIND_POINT;
  end;
  D3D10_EFFECT_VARIABLE_DESC = _D3D10_EFFECT_VARIABLE_DESC;
  TD3D10_EffectVariableDesc = _D3D10_EFFECT_VARIABLE_DESC;


const
  IID_ID3D10EffectVariable: TGUID = '{AE897105-00E6-45bf-BB8E-281DD6DB8E1B}';


type
  // Forward defines
  ID3D10EffectScalarVariable = class;
  ID3D10EffectVectorVariable = class;
  ID3D10EffectMatrixVariable = class;
  ID3D10EffectStringVariable = class;
  ID3D10EffectShaderResourceVariable = class;
  ID3D10EffectRenderTargetViewVariable = class;
  ID3D10EffectDepthStencilViewVariable = class;
  ID3D10EffectConstantBuffer = class;
  ID3D10EffectShaderVariable = class;
  ID3D10EffectBlendVariable = class;
  ID3D10EffectDepthStencilVariable = class;
  ID3D10EffectRasterizerVariable = class;
  ID3D10EffectSamplerVariable = class;

  ID3D10EffectVariable = class
    function IsValid(): BOOL; virtual; stdcall; abstract;
    function GetType(): ID3D10EffectType; virtual; stdcall; abstract;
    function GetDesc(out pDesc: TD3D10_EffectVariableDesc): HResult; virtual; stdcall; abstract;

    function GetAnnotationByIndex(Index: UINT): ID3D10EffectVariable; virtual; stdcall; abstract;
    function GetAnnotationByName(Name: LPCSTR): ID3D10EffectVariable; virtual; stdcall; abstract;

    function GetMemberByIndex(Index: UINT): ID3D10EffectVariable; virtual; stdcall; abstract;
    function GetMemberByName(Name: LPCSTR): ID3D10EffectVariable; virtual; stdcall; abstract;
    function GetMemberBySemantic(Semantic: LPCSTR): ID3D10EffectVariable; virtual; stdcall; abstract;

    function GetElement(Index: UINT): ID3D10EffectVariable; virtual; stdcall; abstract;

    function GetParentConstantBuffer(): ID3D10EffectConstantBuffer; virtual; stdcall; abstract;

    function AsScalar(): ID3D10EffectScalarVariable; virtual; stdcall; abstract;
    function AsVector(): ID3D10EffectVectorVariable; virtual; stdcall; abstract;
    function AsMatrix(): ID3D10EffectMatrixVariable; virtual; stdcall; abstract;
    function AsString(): ID3D10EffectStringVariable; virtual; stdcall; abstract;
    function AsShaderResource(): ID3D10EffectShaderResourceVariable; virtual; stdcall; abstract;
    function AsRenderTargetView(): ID3D10EffectRenderTargetViewVariable; virtual; stdcall; abstract;
    function AsDepthStencilView(): ID3D10EffectDepthStencilViewVariable; virtual; stdcall; abstract;
    function AsConstantBuffer(): ID3D10EffectConstantBuffer; virtual; stdcall; abstract;
    function AsShader(): ID3D10EffectShaderVariable; virtual; stdcall; abstract;
    function AsBlend(): ID3D10EffectBlendVariable; virtual; stdcall; abstract;
    function AsDepthStencil(): ID3D10EffectDepthStencilVariable; virtual; stdcall; abstract;
    function AsRasterizer(): ID3D10EffectRasterizerVariable; virtual; stdcall; abstract;
    function AsSampler(): ID3D10EffectSamplerVariable; virtual; stdcall; abstract;

    function SetRawValue(const pData: Pointer; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetRawValue(pData: Pointer; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectScalarVariable ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


// {00E48F7B-D2C8-49e8-A86C-022DEE53431F}
//DEFINE_GUID(IID_ID3D10EffectScalarVariable,
//0xe48f7b, 0xd2c8, 0x49e8, 0xa8, 0x6c, 0x2, 0x2d, 0xee, 0x53, 0x43, 0x1f);

  ID3D10EffectScalarVariable = class(ID3D10EffectVariable)
    function SetFloat(Value: Single): HResult; virtual; stdcall; abstract;
    function GetFloat(out pValue: Single): HResult; virtual; stdcall; abstract;

    function SetFloatArray(const pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetFloatArray(pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;

    function SetInt(Value: Integer): HResult; virtual; stdcall; abstract;
    function GetInt(out pValue: Integer): HResult; virtual; stdcall; abstract;

    function SetIntArray(const pData: PInteger; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetIntArray(pData: PInteger; Offset, Count: UINT): HResult; virtual; stdcall; abstract;

    function SetBool(Value: BOOL): HResult; virtual; stdcall; abstract;
    function GetBool(out pValue: BOOL): HResult; virtual; stdcall; abstract;

    function SetBoolArray(const pData: PBOOL; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetBoolArray(pData: PBOOL; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectVectorVariable ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {62B98C44-1F82-4c67-BCD0-72CF8F217E81}
//DEFINE_GUID(IID_ID3D10EffectVectorVariable,
//0x62b98c44, 0x1f82, 0x4c67, 0xbc, 0xd0, 0x72, 0xcf, 0x8f, 0x21, 0x7e, 0x81);

  ID3D10EffectVectorVariable = class(ID3D10EffectVariable)
    procedure SetBoolVector(const pData: PBOOL); virtual; stdcall; abstract;
    procedure SetIntVector(const pData: PInteger); virtual; stdcall; abstract;
    function SetFloatVector(const pData: PSingle): HResult; virtual; stdcall; abstract;

    procedure GetBoolVector(pData: PBOOL); virtual; stdcall; abstract;
    procedure GetIntVector(pData: PInteger); virtual; stdcall; abstract;
    function GetFloatVector(pData: PSingle): HResult; virtual; stdcall; abstract;

    procedure SetBoolVectorArray(const pData: PBOOL; Offset, Count: UINT); virtual; stdcall; abstract;
    procedure SetIntVectorArray(const pData: PInteger; Offset, Count: UINT); virtual; stdcall; abstract;
    function SetFloatVectorArray(const pData: PSingle; Offset: UINT; Count: UINT): HResult; virtual; stdcall; abstract;

    procedure GetBoolVectorArray(pData: PBOOL; Offset, Count: UINT); virtual; stdcall; abstract;
    procedure GetIntVectorArray(pData: PInteger; Offset, Count: UINT); virtual; stdcall; abstract;
    function GetFloatVectorArray(pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectMatrixVariable ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {50666C24-B82F-4eed-A172-5B6E7E8522E0}
//DEFINE_GUID(IID_ID3D10EffectMatrixVariable,
//0x50666c24, 0xb82f, 0x4eed, 0xa1, 0x72, 0x5b, 0x6e, 0x7e, 0x85, 0x22, 0xe0);

  ID3D10EffectMatrixVariable = class(ID3D10EffectVariable)
    function SetMatrix(const pData: PSingle): HResult; virtual; stdcall; abstract;
    function GetMatrix(pData: PSingle): HResult; virtual; stdcall; abstract;

    function SetMatrixArray(const pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetMatrixArray(pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;

    function SetMatrixTranspose(pData: PSingle): HResult; virtual; stdcall; abstract;
    function GetMatrixTranspose(pData: PSingle): HResult; virtual; stdcall; abstract;

    function SetMatrixTransposeArray(const pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetMatrixTransposeArray(pData: PSingle; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectStringVariable ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {71417501-8DF9-4e0a-A78A-255F9756BAFF}
//DEFINE_GUID(IID_ID3D10EffectStringVariable,
//0x71417501, 0x8df9, 0x4e0a, 0xa7, 0x8a, 0x25, 0x5f, 0x97, 0x56, 0xba, 0xff);

  ID3D10EffectStringVariable = class(ID3D10EffectVariable)
    function GetString(ppString: LPCSTR): HResult; virtual; stdcall; abstract;
    function GetStringArray(ppStrings: LPCSTR; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectShaderResourceVariable ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {C0A7157B-D872-4b1d-8073-EFC2ACD4B1FC}
//DEFINE_GUID(IID_ID3D10EffectShaderResourceVariable,
//0xc0a7157b, 0xd872, 0x4b1d, 0x80, 0x73, 0xef, 0xc2, 0xac, 0xd4, 0xb1, 0xfc);

  ID3D10EffectShaderResourceVariable = class(ID3D10EffectVariable)
    function SetResource(pResource: ID3D10ShaderResourceView): HResult; virtual; stdcall; abstract;
    function GetResource(out ppResource: ID3D10ShaderResourceView): HResult; virtual; stdcall; abstract;

    function SetResourceArray(const ppResources: PID3D10ShaderResourceView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetResourceArray(ppResources: PID3D10ShaderResourceView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectRenderTargetViewVariable //////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {28CA0CC3-C2C9-40bb-B57F-67B737122B17}
//DEFINE_GUID(IID_ID3D10EffectRenderTargetViewVariable,
//0x28ca0cc3, 0xc2c9, 0x40bb, 0xb5, 0x7f, 0x67, 0xb7, 0x37, 0x12, 0x2b, 0x17);

  ID3D10EffectRenderTargetViewVariable = class(ID3D10EffectVariable)
    function SetRenderTarget(const pResource: ID3D10RenderTargetView): HResult; virtual; stdcall; abstract;
    function GetRenderTarget(ppResource: PID3D10RenderTargetView): HResult; virtual; stdcall; abstract;

    function SetRenderTargetArray(const ppResources: PID3D10RenderTargetView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetRenderTargetArray(ppResources: PID3D10RenderTargetView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectDepthStencilViewVariable //////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {3E02C918-CC79-4985-B622-2D92AD701623}
//DEFINE_GUID(IID_ID3D10EffectDepthStencilViewVariable,
//0x3e02c918, 0xcc79, 0x4985, 0xb6, 0x22, 0x2d, 0x92, 0xad, 0x70, 0x16, 0x23);

  ID3D10EffectDepthStencilViewVariable = class(ID3D10EffectVariable)
    function SetDepthStencil(const pResource: ID3D10DepthStencilView): HResult; virtual; stdcall; abstract;
    function GetDepthStencil(ppResource: PID3D10DepthStencilView): HResult; virtual; stdcall; abstract;

    function SetDepthStencilArray(const ppResources: PID3D10DepthStencilView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
    function GetDepthStencilArray(ppResources: PID3D10DepthStencilView; Offset, Count: UINT): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectConstantBuffer ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {56648F4D-CC8B-4444-A5AD-B5A3D76E91B3}
//DEFINE_GUID(IID_ID3D10EffectConstantBuffer,
//0x56648f4d, 0xcc8b, 0x4444, 0xa5, 0xad, 0xb5, 0xa3, 0xd7, 0x6e, 0x91, 0xb3);

  ID3D10EffectConstantBuffer = class(ID3D10EffectVariable)
    function SetConstantBuffer(const pConstantBuffer: ID3D10Buffer): HResult; virtual; stdcall; abstract;
    function GetConstantBuffer(ppConstantBuffer: PID3D10Buffer): HResult; virtual; stdcall; abstract;

    function SetTextureBuffer(const pTextureBuffer: ID3D10ShaderResourceView): HResult; virtual; stdcall; abstract;
    function GetTextureBuffer(ppTextureBuffer: PID3D10ShaderResourceView): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectShaderVariable ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_EFFECT_SHADER_DESC:
//
// Retrieved by ID3D10EffectShaderVariable::GetShaderDesc()
//----------------------------------------------------------------------------

  PD3D10_EffectShaderDesc = ^TD3D10_EffectShaderDesc;
  _D3D10_EFFECT_SHADER_DESC = record
    pInputSignature: PByte;         // Passed into CreateInputLayout,
                                    // valid on VS and GS only

    IsInline: BOOL;                 // Is this an anonymous shader variable
                                    // resulting from an inline shader assignment?


    // -- The following fields are not valid after Optimize() --
    pBytecode: PByte;               // Shader bytecode
    BytecodeLength: UINT;

    SODecl: LPCSTR;              // Stream out declaration string (for GS with SO)

    NumInputSignatureEntries: UINT;  // Number of entries in the input signature
    NumOutputSignatureEntries: UINT; // Number of entries in the output signature
  end;
  D3D10_EFFECT_SHADER_DESC = _D3D10_EFFECT_SHADER_DESC;
  TD3D10_EffectShaderDesc = _D3D10_EFFECT_SHADER_DESC;


// {80849279-C799-4797-8C33-0407A07D9E06}
//DEFINE_GUID(IID_ID3D10EffectShaderVariable,
//0x80849279, 0xc799, 0x4797, 0x8c, 0x33, 0x4, 0x7, 0xa0, 0x7d, 0x9e, 0x6);

  ID3D10EffectShaderVariable = class(ID3D10EffectVariable)
    function GetShaderDesc(ShaderIndex: UINT; out pDesc: TD3D10_EffectShaderDesc): HResult; virtual; stdcall; abstract;

    function GetVertexShader(ShaderIndex: UINT; out ppVS: ID3D10VertexShader): HResult; virtual; stdcall; abstract;
    function GetGeometryShader(ShaderIndex: UINT; out ppGS: ID3D10GeometryShader): HResult; virtual; stdcall; abstract;
    function GetPixelShader(ShaderIndex: UINT; out ppPS: ID3D10PixelShader): HResult; virtual; stdcall; abstract;

    function GetInputSignatureElementDesc(ShaderIndex: UINT; Element: UINT; out pDesc: TD3D10_SignatureParameterDesc): HResult; virtual; stdcall; abstract;
    function GetOutputSignatureElementDesc(ShaderIndex: UINT; Element: UINT; out pDesc: TD3D10_SignatureParameterDesc): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectBlendVariable /////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {1FCD2294-DF6D-4eae-86B3-0E9160CFB07B}
//DEFINE_GUID(IID_ID3D10EffectBlendVariable,
//0x1fcd2294, 0xdf6d, 0x4eae, 0x86, 0xb3, 0xe, 0x91, 0x60, 0xcf, 0xb0, 0x7b);

  ID3D10EffectBlendVariable = class(ID3D10EffectVariable)
    function GetBlendState(Index: UINT; out ppBlendState: ID3D10BlendState): HResult; virtual; stdcall; abstract;
    function GetBackingStore(Index: UINT; out pBlendDesc: TD3D10_BlendDesc): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectDepthStencilVariable //////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {AF482368-330A-46a5-9A5C-01C71AF24C8D}
//DEFINE_GUID(IID_ID3D10EffectDepthStencilVariable,
//0xaf482368, 0x330a, 0x46a5, 0x9a, 0x5c, 0x1, 0xc7, 0x1a, 0xf2, 0x4c, 0x8d);

  ID3D10EffectDepthStencilVariable = class(ID3D10EffectVariable)
    function GetDepthStencilState(Index: UINT; out ppDepthStencilState: ID3D10DepthStencilState): HResult; virtual; stdcall; abstract;
    function GetBackingStore(Index: UINT; out pDepthStencilDesc: TD3D10_DepthStencilDesc): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectRasterizerVariable ////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {21AF9F0E-4D94-4ea9-9785-2CB76B8C0B34}
//DEFINE_GUID(IID_ID3D10EffectRasterizerVariable,
//0x21af9f0e, 0x4d94, 0x4ea9, 0x97, 0x85, 0x2c, 0xb7, 0x6b, 0x8c, 0xb, 0x34);

  ID3D10EffectRasterizerVariable = class(ID3D10EffectVariable)
    function GetRasterizerState(Index: UINT; out ppRasterizerState: ID3D10RasterizerState): HResult; virtual; stdcall; abstract;
    function GetBackingStore(Index: UINT; out pRasterizerDesc: TD3D10_RasterizerDesc): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectSamplerVariable ///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// {6530D5C7-07E9-4271-A418-E7CE4BD1E480}
//DEFINE_GUID(IID_ID3D10EffectSamplerVariable,
//0x6530d5c7, 0x7e9, 0x4271, 0xa4, 0x18, 0xe7, 0xce, 0x4b, 0xd1, 0xe4, 0x80);

  ID3D10EffectSamplerVariable = class(ID3D10EffectVariable)
    function GetSampler(Index: UINT; out ppSampler: ID3D10SamplerState): HResult; virtual; stdcall; abstract;
    function GetBackingStore(Index: UINT; out pSamplerDesc: TD3D10_SamplerDesc): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectPass //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_PASS_DESC:
//
// Retrieved by ID3D10EffectPass::GetDesc()
//----------------------------------------------------------------------------

  PD3D10_PassDesc = ^TD3D10_PassDesc;
  _D3D10_PASS_DESC = record
    Name: LPCSTR;                // Name of this pass (NULL if not anonymous)
    Annotations: UINT;          // Number of annotations on this pass

    pIAInputSignature: PByte;       // Signature from VS or GS (if there is no VS)
                                    // or NULL if neither exists
    IAInputSignatureSize: SIZE_T;   // Singature size in bytes

    StencilRef: UINT;           // Specified in SetDepthStencilState()
    SampleMask: UINT;           // Specified in SetBlendState()
    BlendFactor: TColorArray;       // Specified in SetBlendState()
  end;
 D3D10_PASS_DESC = _D3D10_PASS_DESC;
 TD3D10_PassDesc = _D3D10_PASS_DESC;


//----------------------------------------------------------------------------
// D3D10_PASS_SHADER_DESC:
//
// Retrieved by ID3D10EffectPass::Get**ShaderDesc()
//----------------------------------------------------------------------------

  PD3D10_PassShaderDesc = ^TD3D10_PassShaderDesc;
  _D3D10_PASS_SHADER_DESC = record
    pShaderVariable: ID3D10EffectShaderVariable;    // The variable that this shader came from.
                                                    // If this is an inline shader assignment,
                                                    //   the returned interface will be an
                                                    //   anonymous shader variable, which is
                                                    //   not retrievable any other way.  It's
                                                    //   name in the variable description will
                                                    //   be "$Anonymous".
                                                    // If there is no assignment of this type in
                                                    //   the pass block, pShaderVariable != NULL,
                                                    //   but pShaderVariable->IsValid() == FALSE.

    ShaderIndex:                        UINT;   // The element of pShaderVariable (if an array)
                                                    // or 0 if not applicable
  end;
  D3D10_PASS_SHADER_DESC = _D3D10_PASS_SHADER_DESC;
  TD3D10_PassShaderDesc = _D3D10_PASS_SHADER_DESC;


// {5CFBEB89-1A06-46e0-B282-E3F9BFA36A54}
//DEFINE_GUID(IID_ID3D10EffectPass,
//0x5cfbeb89, 0x1a06, 0x46e0, 0xb2, 0x82, 0xe3, 0xf9, 0xbf, 0xa3, 0x6a, 0x54);

  ID3D10EffectPass = class
    function IsValid(): BOOL; virtual; stdcall; abstract;
    function GetDesc(out pDesc: TD3D10_PassDesc): HResult; virtual; stdcall; abstract;

    function GetVertexShaderDesc(out pDesc: TD3D10_PassShaderDesc): HResult; virtual; stdcall; abstract;
    function GetGeometryShaderDesc(out pDesc: TD3D10_PassShaderDesc): HResult; virtual; stdcall; abstract;
    function GetPixelShaderDesc(out pDesc: TD3D10_PassShaderDesc): HResult; virtual; stdcall; abstract;

    function GetAnnotationByIndex(Index: UINT): ID3D10EffectVariable; virtual; stdcall; abstract;
    function GetAnnotationByName(Name: LPCSTR): ID3D10EffectVariable; virtual; stdcall; abstract;

    function Apply(Flags: UINT): HResult; virtual; stdcall; abstract;

    function ComputeStateBlockMask(out pStateBlockMask: TD3D10_StateBlockMask): HResult; virtual; stdcall; abstract;
  end;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectTechnique /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_TECHNIQUE_DESC:
//
// Retrieved by ID3D10EffectTechnique::GetDesc()
//----------------------------------------------------------------------------

 PD3D10_TechniqueDesc = ^TD3D10_TechniqueDesc;
  _D3D10_TECHNIQUE_DESC = record
    Name: LPCSTR;          // Name of this technique (NULL if not anonymous)
    Passes: UINT;         // Number of passes contained within
    Annotations: UINT;    // Number of annotations on this technique
  end;
 D3D10_TECHNIQUE_DESC = _D3D10_TECHNIQUE_DESC;
 TD3D10_TechniqueDesc = _D3D10_TECHNIQUE_DESC;


// {DB122CE8-D1C9-4292-B237-24ED3DE8B175}
//DEFINE_GUID(IID_ID3D10EffectTechnique,
//0xdb122ce8, 0xd1c9, 0x4292, 0xb2, 0x37, 0x24, 0xed, 0x3d, 0xe8, 0xb1, 0x75);


  ID3D10EffectTechnique = class
    function IsValid(): BOOL; virtual; stdcall; abstract;
    function GetDesc(out pDesc: TD3D10_TechniqueDesc): HResult; virtual; stdcall; abstract;

    function GetAnnotationByIndex(Index: UINT): ID3D10EffectVariable; virtual; stdcall; abstract;
    function GetAnnotationByName(Name: LPCSTR): ID3D10EffectVariable; virtual; stdcall; abstract;

    function GetPassByIndex(Index: UINT): ID3D10EffectPass; virtual; stdcall; abstract;
    function GetPassByName(Name: LPCSTR): ID3D10EffectPass; virtual; stdcall; abstract;

    function ComputeStateBlockMask(out pStateBlockMask: TD3D10_StateBlockMask): HResult; virtual; stdcall; abstract;
  end;

//////////////////////////////////////////////////////////////////////////////
// ID3D10Effect //////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------------
// D3D10_EFFECT_DESC:
//
// Retrieved by ID3D10Effect::GetDesc()
//----------------------------------------------------------------------------

  PD3D10_EffectDesc = ^TD3D10_EffectDesc;
  _D3D10_EFFECT_DESC = record

    IsChildEffect: BOOL;            // TRUE if this is a child effect,
                                    // FALSE if this is standalone or an effect pool.

    ConstantBuffers: UINT;      // Number of constant buffers in this effect,
                                    // excluding the effect pool.
    SharedConstantBuffers: UINT;// Number of constant buffers shared in this
                                    // effect's pool.

    GlobalVariables: UINT;      // Number of global variables in this effect,
                                    // excluding the effect pool.
    SharedGlobalVariables: UINT;// Number of global variables shared in this
                                    // effect's pool.

    Techniques: UINT;           // Number of techniques in this effect,
                                    // excluding the effect pool.
  end;
  D3D10_EFFECT_DESC = _D3D10_EFFECT_DESC;
  TD3D10_EffectDesc = _D3D10_EFFECT_DESC;



  ID3D10Effect = interface (IUnknown)
    ['{51B0CA8B-EC0B-4519-870D-8EE1CB5017C7}']
    function IsValid(): BOOL; stdcall;
    function IsPool(): BOOL; stdcall;

    // Managing D3D Device
    function GetDevice(out ppDevice: ID3D10Device): HResult; stdcall;

    // New Reflection APIs
    function GetDesc(out pDesc: TD3D10_EffectDesc): HResult; stdcall;

    function GetConstantBufferByIndex(Index: UINT): ID3D10EffectConstantBuffer; stdcall;
    function GetConstantBufferByName(Name: LPCSTR): ID3D10EffectConstantBuffer; stdcall;

    function GetVariableByIndex(Index: UINT): ID3D10EffectVariable; stdcall;
    function GetVariableByName(Name: LPCSTR): ID3D10EffectVariable; stdcall;
    function GetVariableBySemantic(Semantic: LPCSTR): ID3D10EffectVariable; stdcall;

    function GetTechniqueByIndex(Index: UINT): ID3D10EffectTechnique; stdcall;
    function GetTechniqueByName(Name: LPCSTR): ID3D10EffectTechnique; stdcall;

    function Optimize(): HResult; stdcall;
    function IsOptimized(): BOOL; stdcall;
  end;

  IID_ID3D10Effect = ID3D10Effect;


//////////////////////////////////////////////////////////////////////////////
// ID3D10EffectPool //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


  ID3D10EffectPool = interface (IUnknown)
    ['{9537AB04-3250-412e-8213-FCD2F8677933}']
    function AsEffect(): ID3D10Effect;

    // No public methods
  end;

  IID_ID3D10EffectPool = ID3D10EffectPool;



//////////////////////////////////////////////////////////////////////////////
// APIs //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


//----------------------------------------------------------------------------
// D3D10CreateEffectFromXXXX:
// --------------------------
// Creates an effect from a binary effect or file
//
// Parameters:
//
// [in]
//
//
//  pData
//      Blob of effect data, either ASCII (uncompiled, for D3D10CompileEffectFromMemory) or binary (compiled, for D3D10CreateEffect*)
//  DataLength
//      Length of the data blob
//
//  pSrcFileName
//      Name of the ASCII Effect file pData was obtained from
//
//  pDefines
//      Optional NULL-terminated array of preprocessor macro definitions.
//  pInclude
//      Optional interface pointer to use for handling #include directives.
//      If this parameter is NULL, #includes will be honored when compiling
//      from file, and will error when compiling from resource or memory.
//  HLSLFlags
//      Compilation flags pertaining to shaders and data types, honored by
//      the HLSL compiler
//  FXFlags
//      Compilation flags pertaining to Effect compilation, honored
//      by the Effect compiler
//  pDevice
//      Pointer to the D3D10 device on which to create Effect resources
//  pEffectPool
//      Pointer to an Effect pool to share variables with or NULL
//
// [out]
//
//  ppEffect
//      Address of the newly created Effect interface
//  ppEffectPool
//      Address of the newly created Effect pool interface
//  ppErrors
//      If non-NULL, address of a buffer with error messages that occurred
//      during parsing or compilation
//
//----------------------------------------------------------------------------

function D3D10CompileEffectFromMemory(const pData: Pointer; DataLength: SIZE_T; pSrcFileName: LPCSTR; const pDefines: PD3D10_ShaderMacro;
    const pInclude: ID3D10Include; HLSLFlags: UINT; FXFlags: UINT;
    out ppCompiledEffect: ID3D10Blob; ppErrors: PID3D10Blob): HResult; stdcall; external d3d10dll;

function D3D10CreateEffectFromMemory(const pData: Pointer; DataLength: SIZE_T; FXFlags: UINT; const pDevice: ID3D10Device;
    const pEffectPool: ID3D10EffectPool; out ppEffect: ID3D10Effect): HResult; stdcall; external d3d10dll;

function D3D10CreateEffectPoolFromMemory(const pData: Pointer; DataLength: SIZE_T; FXFlags: UINT; const pDevice: ID3D10Device;
    out ppEffectPool: ID3D10EffectPool): HResult; stdcall; external d3d10dll;


//----------------------------------------------------------------------------
// D3D10DisassembleEffect:
// -----------------------
// Takes an effect interface, and returns a buffer containing text assembly.
//
// Parameters:
//  pEffect
//      Pointer to the runtime effect interface.
//  EnableColorCode
//      Emit HTML tags for color coding the output?
//  ppDisassembly
//      Returns a buffer containing the disassembled effect.
//----------------------------------------------------------------------------

function D3D10DisassembleEffect(const pEffect: ID3D10Effect; EnableColorCode: BOOL;
                                      out ppDisassembly: ID3D10Blob): HResult; stdcall; external d3d10dll;

//===========================================================

procedure D3D10_BUFFER_DESC_Create(var aself:D3D10_BUFFER_DESC;
                                   byteWidth, bindFlags: UINT; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                   cpuaccessflags: UINT = 0; miscFlags: UINT = 0);


procedure D3D10_TEXTURE1D_DESC_Create(var aself:D3D10_TEXTURE1D_DESC;
                                      format: DXGI_FORMAT; width: UINT; arraySize: UINT = 1; mipLevels: UINT = 0;
                                      bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage:
                                      D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                      cpuaccessFlags: UINT = 0; miscFlags: UINT = 0);


procedure D3D10_TEXTURE2D_DESC_Create(var aself:D3D10_TEXTURE2D_DESC;
                                        format: DXGI_FORMAT; width: UINT; height: UINT; arraySize: UINT = 1; mipLevels: UINT = 0;
                                        bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                        cpuaccessFlags: UINT = 0; SampleCount: UINT = 1; SampleQuality: UINT = 0; miscFlags: UINT = 0);


procedure D3D10_TEXTURE3D_DESC_Create(var aself:D3D10_TEXTURE3D_DESC;
                                        format: DXGI_FORMAT; width: UINT; height: UINT; depth: UINT; mipLevels: UINT = 0;
                                        bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                        cpuaccessFlags: UINT = 0; miscFlags: UINT = 0);




implementation



//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10.h
//  Content:
//
//////////////////////////////////////////////////////////////////////////////

// #define MAKE_D3D10_HRESULT( code )  MAKE_HRESULT( 1, _FACD3D10, code )
function MAKE_D3D10_HRESULT(Code: DWord): DWord;{$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result:= DWord((1 shl 31) or (_FACD3D10 shl 16)) or Code;
end;

//#define MAKE_D3D10_STATUS( code )    MAKE_HRESULT( 0, _FACD3D10, code )
function MAKE_D3D10_STATUS(Code: DWord): DWord;{$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result:= DWord((0 shl 31) or (_FACD3D10 shl 16)) or Code;
end;

function D3D10CalcSubresource( MipSlice, ArraySlice, MipLevels: UINT): UINT;{$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result:= MipSlice + ArraySlice * MipLevels;
end;

function ColorArray(a, b, c, d: Single): TColorArray;{$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result[0]:= a;
  Result[1]:= b;
  Result[2]:= c;
  Result[3]:= d;
end;


//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10Shader.h
//  Content:    D3D10 Shader Types and APIs
//
//////////////////////////////////////////////////////////////////////////////


//---------------------------------------------------------------------------
// D3D10_TX_VERSION:
// --------------
// Version token used to create a procedural texture filler in effects
// Used by D3D10Fill[]TX functions
//---------------------------------------------------------------------------
//#define D3D10_TX_VERSION(_Major,_Minor) (('T' << 24) | ('X' << 16) | ((_Major) << 8) | (_Minor))
function D3D10_TX_VERSION(_Major, _Minor: Byte): DWORD; {$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result := (Byte('T') shl 24) or (Byte('X') shl 16) or (_Major shl 8) or _Minor;
end;

//////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) Microsoft Corporation.  All rights reserved.
//
//  File:       D3D10Effect.h
//  Content:    D3D10 Stateblock/Effect Types & APIs
//
//////////////////////////////////////////////////////////////////////////////

// #define D3D10_BYTES_FROM_BITS(x) (((x) + 7) / 8)
function D3D10_BYTES_FROM_BITS(x: DWORD): DWORD;{$IFDEF SUPPORTS_INLINE} inline;{$ENDIF}
begin
  Result:=  (x + 7) mod 8;
end;

procedure D3D10_BUFFER_DESC_Create(var aself:D3D10_BUFFER_DESC;
                                   byteWidth, bindFlags: UINT; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                   cpuaccessflags: UINT = 0; miscFlags: UINT = 0);
begin
  aSelf.ByteWidth := byteWidth;
  aSelf.BindFlags := bindFlags;
  aSelf.Usage := usage;
  aSelf.CPUAccessFlags := cpuaccessflags;
  aSelf.MiscFlags := miscFlags;
end;

procedure D3D10_TEXTURE1D_DESC_Create(var aself:D3D10_TEXTURE1D_DESC;
                                      format: DXGI_FORMAT; width: UINT; arraySize: UINT = 1; mipLevels: UINT = 0;
                                      bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage:
                                      D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                      cpuaccessFlags: UINT = 0; miscFlags: UINT = 0);
begin
  aSelf.Format := format;
  aSelf.Width := width;
  aSelf.ArraySize := arraySize;
  aSelf.MipLevels := mipLevels;
  aSelf.BindFlags := bindFlags;
  aSelf.Usage := usage;
  aSelf.CPUAccessFlags := cpuaccessflags;
  aSelf.MiscFlags := miscFlags;
end;

procedure D3D10_TEXTURE2D_DESC_Create(var aself:D3D10_TEXTURE2D_DESC;
                                        format: DXGI_FORMAT; width: UINT; height: UINT; arraySize: UINT = 1; mipLevels: UINT = 0;
                                        bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                        cpuaccessFlags: UINT = 0; SampleCount: UINT = 1; SampleQuality: UINT = 0; miscFlags: UINT = 0);
begin
  aSelf.Format := format;
  aSelf.Width := width;
  aSelf.Height := height;
  aSelf.ArraySize := arraySize;
  aSelf.MipLevels := mipLevels;
  aSelf.BindFlags := bindFlags;
  aSelf.Usage := usage;
  aSelf.CPUAccessFlags := cpuaccessflags;
  aSelf.SampleDesc.Count := SampleCount;
  aSelf.SampleDesc.Quality := SampleQuality;
  aSelf.MiscFlags := miscFlags;
end;

procedure D3D10_TEXTURE3D_DESC_Create(var aself:D3D10_TEXTURE3D_DESC;
                                        format: DXGI_FORMAT; width: UINT; height: UINT; depth: UINT; mipLevels: UINT = 0;
                                        bindFlags: UINT = D3D10_BIND_SHADER_RESOURCE; usage: D3D10_USAGE = D3D10_USAGE_DEFAULT;
                                        cpuaccessFlags: UINT = 0; miscFlags: UINT = 0);
begin
  aSelf.Format := format;
  aSelf.Width := width;
  aSelf.Height := height;
  aSelf.Depth := depth;
  aSelf.MipLevels := mipLevels;
  aSelf.BindFlags := bindFlags;
  aSelf.Usage := usage;
  aSelf.CPUAccessFlags := cpuaccessflags;
  aSelf.MiscFlags := miscFlags;
end;

end.

